<?php

namespace EnumType;

/**
 * This class stands for AvailabilityStatusType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Identifies the availability status of an item.
 * @subpackage Enumerations
 */
class AvailabilityStatusType
{
    /**
     * Constant for value 'Open'
     * Meta information extracted from the WSDL
     * - documentation: Inventory is available for sale.
     * @return string 'Open'
     */
    const VALUE_OPEN = 'Open';
    /**
     * Constant for value 'Close'
     * Meta information extracted from the WSDL
     * - documentation: Inventory is not available for sale.
     * @return string 'Close'
     */
    const VALUE_CLOSE = 'Close';
    /**
     * Constant for value 'ClosedOnArrival'
     * Meta information extracted from the WSDL
     * - documentation: Inventory is not available for sale to arriving guests.
     * @return string 'ClosedOnArrival'
     */
    const VALUE_CLOSED_ON_ARRIVAL = 'ClosedOnArrival';
    /**
     * Constant for value 'ClosedOnArrivalOnRequest'
     * Meta information extracted from the WSDL
     * - documentation: Inventory may not be available for sale to arriving guests.
     * @return string 'ClosedOnArrivalOnRequest'
     */
    const VALUE_CLOSED_ON_ARRIVAL_ON_REQUEST = 'ClosedOnArrivalOnRequest';
    /**
     * Constant for value 'OnRequest'
     * Meta information extracted from the WSDL
     * - documentation: Inventory may be available.
     * @return string 'OnRequest'
     */
    const VALUE_ON_REQUEST = 'OnRequest';
    /**
     * Constant for value 'RemoveCloseOnly'
     * Meta information extracted from the WSDL
     * - documentation: Remove Close restriction while keeping other restrictions in place.
     * @return string 'RemoveCloseOnly'
     */
    const VALUE_REMOVE_CLOSE_ONLY = 'RemoveCloseOnly';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_OPEN
     * @uses self::VALUE_CLOSE
     * @uses self::VALUE_CLOSED_ON_ARRIVAL
     * @uses self::VALUE_CLOSED_ON_ARRIVAL_ON_REQUEST
     * @uses self::VALUE_ON_REQUEST
     * @uses self::VALUE_REMOVE_CLOSE_ONLY
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_OPEN,
            self::VALUE_CLOSE,
            self::VALUE_CLOSED_ON_ARRIVAL,
            self::VALUE_CLOSED_ON_ARRIVAL_ON_REQUEST,
            self::VALUE_ON_REQUEST,
            self::VALUE_REMOVE_CLOSE_ONLY,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
