<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AcceptableGuarantees StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of accepted guarantees.
 * @subpackage Structs
 */
class AcceptableGuarantees extends AbstractStructBase
{
    /**
     * The AcceptableGuarantee
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\AcceptableGuarantee[]
     */
    public $AcceptableGuarantee;
    /**
     * Constructor method for AcceptableGuarantees
     * @uses AcceptableGuarantees::setAcceptableGuarantee()
     * @param \StructType\AcceptableGuarantee[] $acceptableGuarantee
     */
    public function __construct(array $acceptableGuarantee = array())
    {
        $this
            ->setAcceptableGuarantee($acceptableGuarantee);
    }
    /**
     * Get AcceptableGuarantee value
     * @return \StructType\AcceptableGuarantee[]|null
     */
    public function getAcceptableGuarantee()
    {
        return $this->AcceptableGuarantee;
    }
    /**
     * This method is responsible for validating the values passed to the setAcceptableGuarantee method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAcceptableGuarantee method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAcceptableGuaranteeForArrayConstraintsFromSetAcceptableGuarantee(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $acceptableGuaranteesAcceptableGuaranteeItem) {
            // validation for constraint: itemType
            if (!$acceptableGuaranteesAcceptableGuaranteeItem instanceof \StructType\AcceptableGuarantee) {
                $invalidValues[] = is_object($acceptableGuaranteesAcceptableGuaranteeItem) ? get_class($acceptableGuaranteesAcceptableGuaranteeItem) : sprintf('%s(%s)', gettype($acceptableGuaranteesAcceptableGuaranteeItem), var_export($acceptableGuaranteesAcceptableGuaranteeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AcceptableGuarantee property can only contain items of type \StructType\AcceptableGuarantee, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AcceptableGuarantee value
     * @throws \InvalidArgumentException
     * @param \StructType\AcceptableGuarantee[] $acceptableGuarantee
     * @return \StructType\AcceptableGuarantees
     */
    public function setAcceptableGuarantee(array $acceptableGuarantee = array())
    {
        // validation for constraint: array
        if ('' !== ($acceptableGuaranteeArrayErrorMessage = self::validateAcceptableGuaranteeForArrayConstraintsFromSetAcceptableGuarantee($acceptableGuarantee))) {
            throw new \InvalidArgumentException($acceptableGuaranteeArrayErrorMessage, __LINE__);
        }
        $this->AcceptableGuarantee = $acceptableGuarantee;
        return $this;
    }
    /**
     * Add item to AcceptableGuarantee value
     * @throws \InvalidArgumentException
     * @param \StructType\AcceptableGuarantee $item
     * @return \StructType\AcceptableGuarantees
     */
    public function addToAcceptableGuarantee(\StructType\AcceptableGuarantee $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AcceptableGuarantee) {
            throw new \InvalidArgumentException(sprintf('The AcceptableGuarantee property can only contain items of type \StructType\AcceptableGuarantee, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AcceptableGuarantee[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AcceptableGuarantees
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
