<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AcceptablePaymentCardsInfoType StructType
 * Meta information extracted from the WSDL
 * - documentation: This complex type identifies payment cards that are acceptable for a specific form of payment, along with the ability to provide free text information regarding payment cards.
 * @subpackage Structs
 */
class AcceptablePaymentCardsInfoType extends AbstractStructBase
{
    /**
     * The AcceptablePaymentCards
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AcceptablePaymentCards
     */
    public $AcceptablePaymentCards;
    /**
     * The Info
     * Meta information extracted from the WSDL
     * - documentation: General information regarding the use of payment cards.
     * - minOccurs: 0
     * @var \StructType\FormattedTextType
     */
    public $Info;
    /**
     * Constructor method for AcceptablePaymentCardsInfoType
     * @uses AcceptablePaymentCardsInfoType::setAcceptablePaymentCards()
     * @uses AcceptablePaymentCardsInfoType::setInfo()
     * @param \StructType\AcceptablePaymentCards $acceptablePaymentCards
     * @param \StructType\FormattedTextType $info
     */
    public function __construct(\StructType\AcceptablePaymentCards $acceptablePaymentCards = null, \StructType\FormattedTextType $info = null)
    {
        $this
            ->setAcceptablePaymentCards($acceptablePaymentCards)
            ->setInfo($info);
    }
    /**
     * Get AcceptablePaymentCards value
     * @return \StructType\AcceptablePaymentCards|null
     */
    public function getAcceptablePaymentCards()
    {
        return $this->AcceptablePaymentCards;
    }
    /**
     * Set AcceptablePaymentCards value
     * @param \StructType\AcceptablePaymentCards $acceptablePaymentCards
     * @return \StructType\AcceptablePaymentCardsInfoType
     */
    public function setAcceptablePaymentCards(\StructType\AcceptablePaymentCards $acceptablePaymentCards = null)
    {
        $this->AcceptablePaymentCards = $acceptablePaymentCards;
        return $this;
    }
    /**
     * Get Info value
     * @return \StructType\FormattedTextType|null
     */
    public function getInfo()
    {
        return $this->Info;
    }
    /**
     * Set Info value
     * @param \StructType\FormattedTextType $info
     * @return \StructType\AcceptablePaymentCardsInfoType
     */
    public function setInfo(\StructType\FormattedTextType $info = null)
    {
        $this->Info = $info;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AcceptablePaymentCardsInfoType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
