<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdditionalDetailsType StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of AdditionalDetail.
 * @subpackage Structs
 */
class AdditionalDetailsType extends AbstractStructBase
{
    /**
     * The AdditionalDetail
     * Meta information extracted from the WSDL
     * - documentation: Used to send additional information.
     * - maxOccurs: unbounded
     * @var \StructType\AdditionalDetailType[]
     */
    public $AdditionalDetail;
    /**
     * Constructor method for AdditionalDetailsType
     * @uses AdditionalDetailsType::setAdditionalDetail()
     * @param \StructType\AdditionalDetailType[] $additionalDetail
     */
    public function __construct(array $additionalDetail = array())
    {
        $this
            ->setAdditionalDetail($additionalDetail);
    }
    /**
     * Get AdditionalDetail value
     * @return \StructType\AdditionalDetailType[]|null
     */
    public function getAdditionalDetail()
    {
        return $this->AdditionalDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setAdditionalDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdditionalDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdditionalDetailForArrayConstraintsFromSetAdditionalDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $additionalDetailsTypeAdditionalDetailItem) {
            // validation for constraint: itemType
            if (!$additionalDetailsTypeAdditionalDetailItem instanceof \StructType\AdditionalDetailType) {
                $invalidValues[] = is_object($additionalDetailsTypeAdditionalDetailItem) ? get_class($additionalDetailsTypeAdditionalDetailItem) : sprintf('%s(%s)', gettype($additionalDetailsTypeAdditionalDetailItem), var_export($additionalDetailsTypeAdditionalDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdditionalDetail property can only contain items of type \StructType\AdditionalDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdditionalDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\AdditionalDetailType[] $additionalDetail
     * @return \StructType\AdditionalDetailsType
     */
    public function setAdditionalDetail(array $additionalDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($additionalDetailArrayErrorMessage = self::validateAdditionalDetailForArrayConstraintsFromSetAdditionalDetail($additionalDetail))) {
            throw new \InvalidArgumentException($additionalDetailArrayErrorMessage, __LINE__);
        }
        $this->AdditionalDetail = $additionalDetail;
        return $this;
    }
    /**
     * Add item to AdditionalDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\AdditionalDetailType $item
     * @return \StructType\AdditionalDetailsType
     */
    public function addToAdditionalDetail(\StructType\AdditionalDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdditionalDetailType) {
            throw new \InvalidArgumentException(sprintf('The AdditionalDetail property can only contain items of type \StructType\AdditionalDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdditionalDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AdditionalDetailsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
