<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BaseByGuestAmts StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of Base charges by number of guests.
 * @subpackage Structs
 */
class BaseByGuestAmts extends AbstractStructBase
{
    /**
     * The BaseByGuestAmt
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\BaseByGuestAmt[]
     */
    public $BaseByGuestAmt;
    /**
     * Constructor method for BaseByGuestAmts
     * @uses BaseByGuestAmts::setBaseByGuestAmt()
     * @param \StructType\BaseByGuestAmt[] $baseByGuestAmt
     */
    public function __construct(array $baseByGuestAmt = array())
    {
        $this
            ->setBaseByGuestAmt($baseByGuestAmt);
    }
    /**
     * Get BaseByGuestAmt value
     * @return \StructType\BaseByGuestAmt[]|null
     */
    public function getBaseByGuestAmt()
    {
        return $this->BaseByGuestAmt;
    }
    /**
     * This method is responsible for validating the values passed to the setBaseByGuestAmt method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBaseByGuestAmt method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBaseByGuestAmtForArrayConstraintsFromSetBaseByGuestAmt(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $baseByGuestAmtsBaseByGuestAmtItem) {
            // validation for constraint: itemType
            if (!$baseByGuestAmtsBaseByGuestAmtItem instanceof \StructType\BaseByGuestAmt) {
                $invalidValues[] = is_object($baseByGuestAmtsBaseByGuestAmtItem) ? get_class($baseByGuestAmtsBaseByGuestAmtItem) : sprintf('%s(%s)', gettype($baseByGuestAmtsBaseByGuestAmtItem), var_export($baseByGuestAmtsBaseByGuestAmtItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BaseByGuestAmt property can only contain items of type \StructType\BaseByGuestAmt, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BaseByGuestAmt value
     * @throws \InvalidArgumentException
     * @param \StructType\BaseByGuestAmt[] $baseByGuestAmt
     * @return \StructType\BaseByGuestAmts
     */
    public function setBaseByGuestAmt(array $baseByGuestAmt = array())
    {
        // validation for constraint: array
        if ('' !== ($baseByGuestAmtArrayErrorMessage = self::validateBaseByGuestAmtForArrayConstraintsFromSetBaseByGuestAmt($baseByGuestAmt))) {
            throw new \InvalidArgumentException($baseByGuestAmtArrayErrorMessage, __LINE__);
        }
        $this->BaseByGuestAmt = $baseByGuestAmt;
        return $this;
    }
    /**
     * Add item to BaseByGuestAmt value
     * @throws \InvalidArgumentException
     * @param \StructType\BaseByGuestAmt $item
     * @return \StructType\BaseByGuestAmts
     */
    public function addToBaseByGuestAmt(\StructType\BaseByGuestAmt $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BaseByGuestAmt) {
            throw new \InvalidArgumentException(sprintf('The BaseByGuestAmt property can only contain items of type \StructType\BaseByGuestAmt, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BaseByGuestAmt[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BaseByGuestAmts
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
