<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BaseInvCountType StructType
 * Meta information extracted from the WSDL
 * - documentation: The set of changes in the number of units of base inventory for one inventory type (code) to be made on the server. The server must successfully update all messages. Failure to update any single status message will result in the
 * failure of all messages.
 * @subpackage Structs
 */
class BaseInvCountType extends AbstractStructBase
{
    /**
     * The StatusApplicationControl
     * Meta information extracted from the WSDL
     * - documentation: Information on what the InvCountNotif Message applies to (i.e. the combination of inventory and/or rate codes) and the period of application.
     * - minOccurs: 0
     * @var \StructType\StatusApplicationControlType
     */
    public $StatusApplicationControl;
    /**
     * The InvCounts
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\InvCounts
     */
    public $InvCounts;
    /**
     * The OffSell
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OffSell
     */
    public $OffSell;
    /**
     * The UniqueID
     * Meta information extracted from the WSDL
     * - documentation: The unique identifier element allows the trading partners to uniquely identify each InvCountNotifRQ, (i.e. the entire message) for transaction traceability.
     * - minOccurs: 0
     * @var \StructType\UniqueID_Type
     */
    public $UniqueID;
    /**
     * Constructor method for BaseInvCountType
     * @uses BaseInvCountType::setStatusApplicationControl()
     * @uses BaseInvCountType::setInvCounts()
     * @uses BaseInvCountType::setOffSell()
     * @uses BaseInvCountType::setUniqueID()
     * @param \StructType\StatusApplicationControlType $statusApplicationControl
     * @param \StructType\InvCounts $invCounts
     * @param \StructType\OffSell $offSell
     * @param \StructType\UniqueID_Type $uniqueID
     */
    public function __construct(\StructType\StatusApplicationControlType $statusApplicationControl = null, \StructType\InvCounts $invCounts = null, \StructType\OffSell $offSell = null, \StructType\UniqueID_Type $uniqueID = null)
    {
        $this
            ->setStatusApplicationControl($statusApplicationControl)
            ->setInvCounts($invCounts)
            ->setOffSell($offSell)
            ->setUniqueID($uniqueID);
    }
    /**
     * Get StatusApplicationControl value
     * @return \StructType\StatusApplicationControlType|null
     */
    public function getStatusApplicationControl()
    {
        return $this->StatusApplicationControl;
    }
    /**
     * Set StatusApplicationControl value
     * @param \StructType\StatusApplicationControlType $statusApplicationControl
     * @return \StructType\BaseInvCountType
     */
    public function setStatusApplicationControl(\StructType\StatusApplicationControlType $statusApplicationControl = null)
    {
        $this->StatusApplicationControl = $statusApplicationControl;
        return $this;
    }
    /**
     * Get InvCounts value
     * @return \StructType\InvCounts|null
     */
    public function getInvCounts()
    {
        return $this->InvCounts;
    }
    /**
     * Set InvCounts value
     * @param \StructType\InvCounts $invCounts
     * @return \StructType\BaseInvCountType
     */
    public function setInvCounts(\StructType\InvCounts $invCounts = null)
    {
        $this->InvCounts = $invCounts;
        return $this;
    }
    /**
     * Get OffSell value
     * @return \StructType\OffSell|null
     */
    public function getOffSell()
    {
        return $this->OffSell;
    }
    /**
     * Set OffSell value
     * @param \StructType\OffSell $offSell
     * @return \StructType\BaseInvCountType
     */
    public function setOffSell(\StructType\OffSell $offSell = null)
    {
        $this->OffSell = $offSell;
        return $this;
    }
    /**
     * Get UniqueID value
     * @return \StructType\UniqueID_Type|null
     */
    public function getUniqueID()
    {
        return $this->UniqueID;
    }
    /**
     * Set UniqueID value
     * @param \StructType\UniqueID_Type $uniqueID
     * @return \StructType\BaseInvCountType
     */
    public function setUniqueID(\StructType\UniqueID_Type $uniqueID = null)
    {
        $this->UniqueID = $uniqueID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BaseInvCountType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
