<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BestAvailableRates StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of the best rates available.
 * @subpackage Structs
 */
class BestAvailableRates extends AbstractStructBase
{
    /**
     * The BestAvailableRate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\BestAvailableRate[]
     */
    public $BestAvailableRate;
    /**
     * Constructor method for BestAvailableRates
     * @uses BestAvailableRates::setBestAvailableRate()
     * @param \StructType\BestAvailableRate[] $bestAvailableRate
     */
    public function __construct(array $bestAvailableRate = array())
    {
        $this
            ->setBestAvailableRate($bestAvailableRate);
    }
    /**
     * Get BestAvailableRate value
     * @return \StructType\BestAvailableRate[]|null
     */
    public function getBestAvailableRate()
    {
        return $this->BestAvailableRate;
    }
    /**
     * This method is responsible for validating the values passed to the setBestAvailableRate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBestAvailableRate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBestAvailableRateForArrayConstraintsFromSetBestAvailableRate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $bestAvailableRatesBestAvailableRateItem) {
            // validation for constraint: itemType
            if (!$bestAvailableRatesBestAvailableRateItem instanceof \StructType\BestAvailableRate) {
                $invalidValues[] = is_object($bestAvailableRatesBestAvailableRateItem) ? get_class($bestAvailableRatesBestAvailableRateItem) : sprintf('%s(%s)', gettype($bestAvailableRatesBestAvailableRateItem), var_export($bestAvailableRatesBestAvailableRateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BestAvailableRate property can only contain items of type \StructType\BestAvailableRate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BestAvailableRate value
     * @throws \InvalidArgumentException
     * @param \StructType\BestAvailableRate[] $bestAvailableRate
     * @return \StructType\BestAvailableRates
     */
    public function setBestAvailableRate(array $bestAvailableRate = array())
    {
        // validation for constraint: array
        if ('' !== ($bestAvailableRateArrayErrorMessage = self::validateBestAvailableRateForArrayConstraintsFromSetBestAvailableRate($bestAvailableRate))) {
            throw new \InvalidArgumentException($bestAvailableRateArrayErrorMessage, __LINE__);
        }
        $this->BestAvailableRate = $bestAvailableRate;
        return $this;
    }
    /**
     * Add item to BestAvailableRate value
     * @throws \InvalidArgumentException
     * @param \StructType\BestAvailableRate $item
     * @return \StructType\BestAvailableRates
     */
    public function addToBestAvailableRate(\StructType\BestAvailableRate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BestAvailableRate) {
            throw new \InvalidArgumentException(sprintf('The BestAvailableRate property can only contain items of type \StructType\BestAvailableRate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BestAvailableRate[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BestAvailableRates
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
