<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BookingRulesType StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of BookingRule.
 * @subpackage Structs
 */
class BookingRulesType extends AbstractStructBase
{
    /**
     * The BookingRule
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\BookingRule[]
     */
    public $BookingRule;
    /**
     * Constructor method for BookingRulesType
     * @uses BookingRulesType::setBookingRule()
     * @param \StructType\BookingRule[] $bookingRule
     */
    public function __construct(array $bookingRule = array())
    {
        $this
            ->setBookingRule($bookingRule);
    }
    /**
     * Get BookingRule value
     * @return \StructType\BookingRule[]|null
     */
    public function getBookingRule()
    {
        return $this->BookingRule;
    }
    /**
     * This method is responsible for validating the values passed to the setBookingRule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBookingRule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBookingRuleForArrayConstraintsFromSetBookingRule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $bookingRulesTypeBookingRuleItem) {
            // validation for constraint: itemType
            if (!$bookingRulesTypeBookingRuleItem instanceof \StructType\BookingRule) {
                $invalidValues[] = is_object($bookingRulesTypeBookingRuleItem) ? get_class($bookingRulesTypeBookingRuleItem) : sprintf('%s(%s)', gettype($bookingRulesTypeBookingRuleItem), var_export($bookingRulesTypeBookingRuleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BookingRule property can only contain items of type \StructType\BookingRule, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BookingRule value
     * @throws \InvalidArgumentException
     * @param \StructType\BookingRule[] $bookingRule
     * @return \StructType\BookingRulesType
     */
    public function setBookingRule(array $bookingRule = array())
    {
        // validation for constraint: array
        if ('' !== ($bookingRuleArrayErrorMessage = self::validateBookingRuleForArrayConstraintsFromSetBookingRule($bookingRule))) {
            throw new \InvalidArgumentException($bookingRuleArrayErrorMessage, __LINE__);
        }
        $this->BookingRule = $bookingRule;
        return $this;
    }
    /**
     * Add item to BookingRule value
     * @throws \InvalidArgumentException
     * @param \StructType\BookingRule $item
     * @return \StructType\BookingRulesType
     */
    public function addToBookingRule(\StructType\BookingRule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BookingRule) {
            throw new \InvalidArgumentException(sprintf('The BookingRule property can only contain items of type \StructType\BookingRule, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BookingRule[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BookingRulesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
