<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CommonPrefType StructType
 * Meta information extracted from the WSDL
 * - documentation: Used to specify the preferred alternate language. | Used to specify the preferred language. | Used to indicate if smoking is preferred. | Allows for control of the sharing of common preferences between parties. | Identifies
 * preferences for common travel needs not associated with a specific travel service.
 * @subpackage Structs
 */
class CommonPrefType extends AbstractStructBase
{
    /**
     * The NamePref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for name information.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\NamePrefType[]
     */
    public $NamePref;
    /**
     * The PhonePref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for telephone information.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PhonePrefType[]
     */
    public $PhonePref;
    /**
     * The AddressPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for address information.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AddressPrefType[]
     */
    public $AddressPref;
    /**
     * The PaymentFormPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for form of payment.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PaymentFormPrefType[]
     */
    public $PaymentFormPref;
    /**
     * The InterestPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for a traveler's interests.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\InterestPrefType[]
     */
    public $InterestPref;
    /**
     * The InsurancePref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for insurance.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\InsurancePrefType[]
     */
    public $InsurancePref;
    /**
     * The SeatingPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for seating.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SeatingPrefType[]
     */
    public $SeatingPref;
    /**
     * The TicketDistribPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for a method of ticket distribution.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\TicketDistribPrefType[]
     */
    public $TicketDistribPref;
    /**
     * The MediaEntertainPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for media and entertainment.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MediaEntertainPrefType[]
     */
    public $MediaEntertainPref;
    /**
     * The PetInfoPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for pet information.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PetInfoPrefType[]
     */
    public $PetInfoPref;
    /**
     * The MealPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for food and beverage.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MealPrefType[]
     */
    public $MealPref;
    /**
     * The LoyaltyPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for a loyalty program.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\LoyaltyPrefType[]
     */
    public $LoyaltyPref;
    /**
     * The SpecRequestPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for a special request.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SpecRequestPrefType[]
     */
    public $SpecRequestPref;
    /**
     * The RelatedTravelerPref
     * Meta information extracted from the WSDL
     * - documentation: Enables a preference to be indicated for a related traveler.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RelatedTravelerPrefType[]
     */
    public $RelatedTravelerPref;
    /**
     * The ContactPref
     * Meta information extracted from the WSDL
     * - maxOccurs: 99
     * - minOccurs: 0
     * @var \StructType\ContactPref[]
     */
    public $ContactPref;
    /**
     * The EmployeeLevelInfo
     * Meta information extracted from the WSDL
     * - documentation: Defines the category of the traveler and the purpose of the trip for which these preferences apply. Typically used for company profiles.
     * - minOccurs: 0
     * @var \StructType\EmployeeInfoType
     */
    public $EmployeeLevelInfo;
    /**
     * The TPA_Extensions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: TPA_Extensions
     * @var \StructType\TPA_ExtensionsType
     */
    public $TPA_Extensions;
    /**
     * The ShareSynchInd
     * @var string
     */
    public $ShareSynchInd;
    /**
     * The ShareMarketInd
     * @var string
     */
    public $ShareMarketInd;
    /**
     * The SmokingAllowed
     * @var bool
     */
    public $SmokingAllowed;
    /**
     * The PrimaryLangID
     * @var string
     */
    public $PrimaryLangID;
    /**
     * The AltLangID
     * @var string
     */
    public $AltLangID;
    /**
     * Constructor method for CommonPrefType
     * @uses CommonPrefType::setNamePref()
     * @uses CommonPrefType::setPhonePref()
     * @uses CommonPrefType::setAddressPref()
     * @uses CommonPrefType::setPaymentFormPref()
     * @uses CommonPrefType::setInterestPref()
     * @uses CommonPrefType::setInsurancePref()
     * @uses CommonPrefType::setSeatingPref()
     * @uses CommonPrefType::setTicketDistribPref()
     * @uses CommonPrefType::setMediaEntertainPref()
     * @uses CommonPrefType::setPetInfoPref()
     * @uses CommonPrefType::setMealPref()
     * @uses CommonPrefType::setLoyaltyPref()
     * @uses CommonPrefType::setSpecRequestPref()
     * @uses CommonPrefType::setRelatedTravelerPref()
     * @uses CommonPrefType::setContactPref()
     * @uses CommonPrefType::setEmployeeLevelInfo()
     * @uses CommonPrefType::setTPA_Extensions()
     * @uses CommonPrefType::setShareSynchInd()
     * @uses CommonPrefType::setShareMarketInd()
     * @uses CommonPrefType::setSmokingAllowed()
     * @uses CommonPrefType::setPrimaryLangID()
     * @uses CommonPrefType::setAltLangID()
     * @param \StructType\NamePrefType[] $namePref
     * @param \StructType\PhonePrefType[] $phonePref
     * @param \StructType\AddressPrefType[] $addressPref
     * @param \StructType\PaymentFormPrefType[] $paymentFormPref
     * @param \StructType\InterestPrefType[] $interestPref
     * @param \StructType\InsurancePrefType[] $insurancePref
     * @param \StructType\SeatingPrefType[] $seatingPref
     * @param \StructType\TicketDistribPrefType[] $ticketDistribPref
     * @param \StructType\MediaEntertainPrefType[] $mediaEntertainPref
     * @param \StructType\PetInfoPrefType[] $petInfoPref
     * @param \StructType\MealPrefType[] $mealPref
     * @param \StructType\LoyaltyPrefType[] $loyaltyPref
     * @param \StructType\SpecRequestPrefType[] $specRequestPref
     * @param \StructType\RelatedTravelerPrefType[] $relatedTravelerPref
     * @param \StructType\ContactPref[] $contactPref
     * @param \StructType\EmployeeInfoType $employeeLevelInfo
     * @param \StructType\TPA_ExtensionsType $tPA_Extensions
     * @param string $shareSynchInd
     * @param string $shareMarketInd
     * @param bool $smokingAllowed
     * @param string $primaryLangID
     * @param string $altLangID
     */
    public function __construct(array $namePref = array(), array $phonePref = array(), array $addressPref = array(), array $paymentFormPref = array(), array $interestPref = array(), array $insurancePref = array(), array $seatingPref = array(), array $ticketDistribPref = array(), array $mediaEntertainPref = array(), array $petInfoPref = array(), array $mealPref = array(), array $loyaltyPref = array(), array $specRequestPref = array(), array $relatedTravelerPref = array(), array $contactPref = array(), \StructType\EmployeeInfoType $employeeLevelInfo = null, \StructType\TPA_ExtensionsType $tPA_Extensions = null, $shareSynchInd = null, $shareMarketInd = null, $smokingAllowed = null, $primaryLangID = null, $altLangID = null)
    {
        $this
            ->setNamePref($namePref)
            ->setPhonePref($phonePref)
            ->setAddressPref($addressPref)
            ->setPaymentFormPref($paymentFormPref)
            ->setInterestPref($interestPref)
            ->setInsurancePref($insurancePref)
            ->setSeatingPref($seatingPref)
            ->setTicketDistribPref($ticketDistribPref)
            ->setMediaEntertainPref($mediaEntertainPref)
            ->setPetInfoPref($petInfoPref)
            ->setMealPref($mealPref)
            ->setLoyaltyPref($loyaltyPref)
            ->setSpecRequestPref($specRequestPref)
            ->setRelatedTravelerPref($relatedTravelerPref)
            ->setContactPref($contactPref)
            ->setEmployeeLevelInfo($employeeLevelInfo)
            ->setTPA_Extensions($tPA_Extensions)
            ->setShareSynchInd($shareSynchInd)
            ->setShareMarketInd($shareMarketInd)
            ->setSmokingAllowed($smokingAllowed)
            ->setPrimaryLangID($primaryLangID)
            ->setAltLangID($altLangID);
    }
    /**
     * Get NamePref value
     * @return \StructType\NamePrefType[]|null
     */
    public function getNamePref()
    {
        return $this->NamePref;
    }
    /**
     * This method is responsible for validating the values passed to the setNamePref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNamePref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNamePrefForArrayConstraintsFromSetNamePref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeNamePrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeNamePrefItem instanceof \StructType\NamePrefType) {
                $invalidValues[] = is_object($commonPrefTypeNamePrefItem) ? get_class($commonPrefTypeNamePrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeNamePrefItem), var_export($commonPrefTypeNamePrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The NamePref property can only contain items of type \StructType\NamePrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set NamePref value
     * @throws \InvalidArgumentException
     * @param \StructType\NamePrefType[] $namePref
     * @return \StructType\CommonPrefType
     */
    public function setNamePref(array $namePref = array())
    {
        // validation for constraint: array
        if ('' !== ($namePrefArrayErrorMessage = self::validateNamePrefForArrayConstraintsFromSetNamePref($namePref))) {
            throw new \InvalidArgumentException($namePrefArrayErrorMessage, __LINE__);
        }
        $this->NamePref = $namePref;
        return $this;
    }
    /**
     * Add item to NamePref value
     * @throws \InvalidArgumentException
     * @param \StructType\NamePrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToNamePref(\StructType\NamePrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\NamePrefType) {
            throw new \InvalidArgumentException(sprintf('The NamePref property can only contain items of type \StructType\NamePrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->NamePref[] = $item;
        return $this;
    }
    /**
     * Get PhonePref value
     * @return \StructType\PhonePrefType[]|null
     */
    public function getPhonePref()
    {
        return $this->PhonePref;
    }
    /**
     * This method is responsible for validating the values passed to the setPhonePref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPhonePref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePhonePrefForArrayConstraintsFromSetPhonePref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypePhonePrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypePhonePrefItem instanceof \StructType\PhonePrefType) {
                $invalidValues[] = is_object($commonPrefTypePhonePrefItem) ? get_class($commonPrefTypePhonePrefItem) : sprintf('%s(%s)', gettype($commonPrefTypePhonePrefItem), var_export($commonPrefTypePhonePrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PhonePref property can only contain items of type \StructType\PhonePrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PhonePref value
     * @throws \InvalidArgumentException
     * @param \StructType\PhonePrefType[] $phonePref
     * @return \StructType\CommonPrefType
     */
    public function setPhonePref(array $phonePref = array())
    {
        // validation for constraint: array
        if ('' !== ($phonePrefArrayErrorMessage = self::validatePhonePrefForArrayConstraintsFromSetPhonePref($phonePref))) {
            throw new \InvalidArgumentException($phonePrefArrayErrorMessage, __LINE__);
        }
        $this->PhonePref = $phonePref;
        return $this;
    }
    /**
     * Add item to PhonePref value
     * @throws \InvalidArgumentException
     * @param \StructType\PhonePrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToPhonePref(\StructType\PhonePrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PhonePrefType) {
            throw new \InvalidArgumentException(sprintf('The PhonePref property can only contain items of type \StructType\PhonePrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PhonePref[] = $item;
        return $this;
    }
    /**
     * Get AddressPref value
     * @return \StructType\AddressPrefType[]|null
     */
    public function getAddressPref()
    {
        return $this->AddressPref;
    }
    /**
     * This method is responsible for validating the values passed to the setAddressPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAddressPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAddressPrefForArrayConstraintsFromSetAddressPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeAddressPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeAddressPrefItem instanceof \StructType\AddressPrefType) {
                $invalidValues[] = is_object($commonPrefTypeAddressPrefItem) ? get_class($commonPrefTypeAddressPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeAddressPrefItem), var_export($commonPrefTypeAddressPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AddressPref property can only contain items of type \StructType\AddressPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AddressPref value
     * @throws \InvalidArgumentException
     * @param \StructType\AddressPrefType[] $addressPref
     * @return \StructType\CommonPrefType
     */
    public function setAddressPref(array $addressPref = array())
    {
        // validation for constraint: array
        if ('' !== ($addressPrefArrayErrorMessage = self::validateAddressPrefForArrayConstraintsFromSetAddressPref($addressPref))) {
            throw new \InvalidArgumentException($addressPrefArrayErrorMessage, __LINE__);
        }
        $this->AddressPref = $addressPref;
        return $this;
    }
    /**
     * Add item to AddressPref value
     * @throws \InvalidArgumentException
     * @param \StructType\AddressPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToAddressPref(\StructType\AddressPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AddressPrefType) {
            throw new \InvalidArgumentException(sprintf('The AddressPref property can only contain items of type \StructType\AddressPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AddressPref[] = $item;
        return $this;
    }
    /**
     * Get PaymentFormPref value
     * @return \StructType\PaymentFormPrefType[]|null
     */
    public function getPaymentFormPref()
    {
        return $this->PaymentFormPref;
    }
    /**
     * This method is responsible for validating the values passed to the setPaymentFormPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaymentFormPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaymentFormPrefForArrayConstraintsFromSetPaymentFormPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypePaymentFormPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypePaymentFormPrefItem instanceof \StructType\PaymentFormPrefType) {
                $invalidValues[] = is_object($commonPrefTypePaymentFormPrefItem) ? get_class($commonPrefTypePaymentFormPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypePaymentFormPrefItem), var_export($commonPrefTypePaymentFormPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PaymentFormPref property can only contain items of type \StructType\PaymentFormPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PaymentFormPref value
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentFormPrefType[] $paymentFormPref
     * @return \StructType\CommonPrefType
     */
    public function setPaymentFormPref(array $paymentFormPref = array())
    {
        // validation for constraint: array
        if ('' !== ($paymentFormPrefArrayErrorMessage = self::validatePaymentFormPrefForArrayConstraintsFromSetPaymentFormPref($paymentFormPref))) {
            throw new \InvalidArgumentException($paymentFormPrefArrayErrorMessage, __LINE__);
        }
        $this->PaymentFormPref = $paymentFormPref;
        return $this;
    }
    /**
     * Add item to PaymentFormPref value
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentFormPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToPaymentFormPref(\StructType\PaymentFormPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaymentFormPrefType) {
            throw new \InvalidArgumentException(sprintf('The PaymentFormPref property can only contain items of type \StructType\PaymentFormPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PaymentFormPref[] = $item;
        return $this;
    }
    /**
     * Get InterestPref value
     * @return \StructType\InterestPrefType[]|null
     */
    public function getInterestPref()
    {
        return $this->InterestPref;
    }
    /**
     * This method is responsible for validating the values passed to the setInterestPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterestPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterestPrefForArrayConstraintsFromSetInterestPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeInterestPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeInterestPrefItem instanceof \StructType\InterestPrefType) {
                $invalidValues[] = is_object($commonPrefTypeInterestPrefItem) ? get_class($commonPrefTypeInterestPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeInterestPrefItem), var_export($commonPrefTypeInterestPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InterestPref property can only contain items of type \StructType\InterestPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InterestPref value
     * @throws \InvalidArgumentException
     * @param \StructType\InterestPrefType[] $interestPref
     * @return \StructType\CommonPrefType
     */
    public function setInterestPref(array $interestPref = array())
    {
        // validation for constraint: array
        if ('' !== ($interestPrefArrayErrorMessage = self::validateInterestPrefForArrayConstraintsFromSetInterestPref($interestPref))) {
            throw new \InvalidArgumentException($interestPrefArrayErrorMessage, __LINE__);
        }
        $this->InterestPref = $interestPref;
        return $this;
    }
    /**
     * Add item to InterestPref value
     * @throws \InvalidArgumentException
     * @param \StructType\InterestPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToInterestPref(\StructType\InterestPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterestPrefType) {
            throw new \InvalidArgumentException(sprintf('The InterestPref property can only contain items of type \StructType\InterestPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InterestPref[] = $item;
        return $this;
    }
    /**
     * Get InsurancePref value
     * @return \StructType\InsurancePrefType[]|null
     */
    public function getInsurancePref()
    {
        return $this->InsurancePref;
    }
    /**
     * This method is responsible for validating the values passed to the setInsurancePref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInsurancePref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInsurancePrefForArrayConstraintsFromSetInsurancePref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeInsurancePrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeInsurancePrefItem instanceof \StructType\InsurancePrefType) {
                $invalidValues[] = is_object($commonPrefTypeInsurancePrefItem) ? get_class($commonPrefTypeInsurancePrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeInsurancePrefItem), var_export($commonPrefTypeInsurancePrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InsurancePref property can only contain items of type \StructType\InsurancePrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InsurancePref value
     * @throws \InvalidArgumentException
     * @param \StructType\InsurancePrefType[] $insurancePref
     * @return \StructType\CommonPrefType
     */
    public function setInsurancePref(array $insurancePref = array())
    {
        // validation for constraint: array
        if ('' !== ($insurancePrefArrayErrorMessage = self::validateInsurancePrefForArrayConstraintsFromSetInsurancePref($insurancePref))) {
            throw new \InvalidArgumentException($insurancePrefArrayErrorMessage, __LINE__);
        }
        $this->InsurancePref = $insurancePref;
        return $this;
    }
    /**
     * Add item to InsurancePref value
     * @throws \InvalidArgumentException
     * @param \StructType\InsurancePrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToInsurancePref(\StructType\InsurancePrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InsurancePrefType) {
            throw new \InvalidArgumentException(sprintf('The InsurancePref property can only contain items of type \StructType\InsurancePrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InsurancePref[] = $item;
        return $this;
    }
    /**
     * Get SeatingPref value
     * @return \StructType\SeatingPrefType[]|null
     */
    public function getSeatingPref()
    {
        return $this->SeatingPref;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatingPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatingPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatingPrefForArrayConstraintsFromSetSeatingPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeSeatingPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeSeatingPrefItem instanceof \StructType\SeatingPrefType) {
                $invalidValues[] = is_object($commonPrefTypeSeatingPrefItem) ? get_class($commonPrefTypeSeatingPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeSeatingPrefItem), var_export($commonPrefTypeSeatingPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatingPref property can only contain items of type \StructType\SeatingPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatingPref value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatingPrefType[] $seatingPref
     * @return \StructType\CommonPrefType
     */
    public function setSeatingPref(array $seatingPref = array())
    {
        // validation for constraint: array
        if ('' !== ($seatingPrefArrayErrorMessage = self::validateSeatingPrefForArrayConstraintsFromSetSeatingPref($seatingPref))) {
            throw new \InvalidArgumentException($seatingPrefArrayErrorMessage, __LINE__);
        }
        $this->SeatingPref = $seatingPref;
        return $this;
    }
    /**
     * Add item to SeatingPref value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatingPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToSeatingPref(\StructType\SeatingPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatingPrefType) {
            throw new \InvalidArgumentException(sprintf('The SeatingPref property can only contain items of type \StructType\SeatingPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatingPref[] = $item;
        return $this;
    }
    /**
     * Get TicketDistribPref value
     * @return \StructType\TicketDistribPrefType[]|null
     */
    public function getTicketDistribPref()
    {
        return $this->TicketDistribPref;
    }
    /**
     * This method is responsible for validating the values passed to the setTicketDistribPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTicketDistribPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTicketDistribPrefForArrayConstraintsFromSetTicketDistribPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeTicketDistribPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeTicketDistribPrefItem instanceof \StructType\TicketDistribPrefType) {
                $invalidValues[] = is_object($commonPrefTypeTicketDistribPrefItem) ? get_class($commonPrefTypeTicketDistribPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeTicketDistribPrefItem), var_export($commonPrefTypeTicketDistribPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TicketDistribPref property can only contain items of type \StructType\TicketDistribPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TicketDistribPref value
     * @throws \InvalidArgumentException
     * @param \StructType\TicketDistribPrefType[] $ticketDistribPref
     * @return \StructType\CommonPrefType
     */
    public function setTicketDistribPref(array $ticketDistribPref = array())
    {
        // validation for constraint: array
        if ('' !== ($ticketDistribPrefArrayErrorMessage = self::validateTicketDistribPrefForArrayConstraintsFromSetTicketDistribPref($ticketDistribPref))) {
            throw new \InvalidArgumentException($ticketDistribPrefArrayErrorMessage, __LINE__);
        }
        $this->TicketDistribPref = $ticketDistribPref;
        return $this;
    }
    /**
     * Add item to TicketDistribPref value
     * @throws \InvalidArgumentException
     * @param \StructType\TicketDistribPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToTicketDistribPref(\StructType\TicketDistribPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TicketDistribPrefType) {
            throw new \InvalidArgumentException(sprintf('The TicketDistribPref property can only contain items of type \StructType\TicketDistribPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TicketDistribPref[] = $item;
        return $this;
    }
    /**
     * Get MediaEntertainPref value
     * @return \StructType\MediaEntertainPrefType[]|null
     */
    public function getMediaEntertainPref()
    {
        return $this->MediaEntertainPref;
    }
    /**
     * This method is responsible for validating the values passed to the setMediaEntertainPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMediaEntertainPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMediaEntertainPrefForArrayConstraintsFromSetMediaEntertainPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeMediaEntertainPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeMediaEntertainPrefItem instanceof \StructType\MediaEntertainPrefType) {
                $invalidValues[] = is_object($commonPrefTypeMediaEntertainPrefItem) ? get_class($commonPrefTypeMediaEntertainPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeMediaEntertainPrefItem), var_export($commonPrefTypeMediaEntertainPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MediaEntertainPref property can only contain items of type \StructType\MediaEntertainPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MediaEntertainPref value
     * @throws \InvalidArgumentException
     * @param \StructType\MediaEntertainPrefType[] $mediaEntertainPref
     * @return \StructType\CommonPrefType
     */
    public function setMediaEntertainPref(array $mediaEntertainPref = array())
    {
        // validation for constraint: array
        if ('' !== ($mediaEntertainPrefArrayErrorMessage = self::validateMediaEntertainPrefForArrayConstraintsFromSetMediaEntertainPref($mediaEntertainPref))) {
            throw new \InvalidArgumentException($mediaEntertainPrefArrayErrorMessage, __LINE__);
        }
        $this->MediaEntertainPref = $mediaEntertainPref;
        return $this;
    }
    /**
     * Add item to MediaEntertainPref value
     * @throws \InvalidArgumentException
     * @param \StructType\MediaEntertainPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToMediaEntertainPref(\StructType\MediaEntertainPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MediaEntertainPrefType) {
            throw new \InvalidArgumentException(sprintf('The MediaEntertainPref property can only contain items of type \StructType\MediaEntertainPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MediaEntertainPref[] = $item;
        return $this;
    }
    /**
     * Get PetInfoPref value
     * @return \StructType\PetInfoPrefType[]|null
     */
    public function getPetInfoPref()
    {
        return $this->PetInfoPref;
    }
    /**
     * This method is responsible for validating the values passed to the setPetInfoPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPetInfoPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePetInfoPrefForArrayConstraintsFromSetPetInfoPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypePetInfoPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypePetInfoPrefItem instanceof \StructType\PetInfoPrefType) {
                $invalidValues[] = is_object($commonPrefTypePetInfoPrefItem) ? get_class($commonPrefTypePetInfoPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypePetInfoPrefItem), var_export($commonPrefTypePetInfoPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PetInfoPref property can only contain items of type \StructType\PetInfoPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PetInfoPref value
     * @throws \InvalidArgumentException
     * @param \StructType\PetInfoPrefType[] $petInfoPref
     * @return \StructType\CommonPrefType
     */
    public function setPetInfoPref(array $petInfoPref = array())
    {
        // validation for constraint: array
        if ('' !== ($petInfoPrefArrayErrorMessage = self::validatePetInfoPrefForArrayConstraintsFromSetPetInfoPref($petInfoPref))) {
            throw new \InvalidArgumentException($petInfoPrefArrayErrorMessage, __LINE__);
        }
        $this->PetInfoPref = $petInfoPref;
        return $this;
    }
    /**
     * Add item to PetInfoPref value
     * @throws \InvalidArgumentException
     * @param \StructType\PetInfoPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToPetInfoPref(\StructType\PetInfoPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PetInfoPrefType) {
            throw new \InvalidArgumentException(sprintf('The PetInfoPref property can only contain items of type \StructType\PetInfoPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PetInfoPref[] = $item;
        return $this;
    }
    /**
     * Get MealPref value
     * @return \StructType\MealPrefType[]|null
     */
    public function getMealPref()
    {
        return $this->MealPref;
    }
    /**
     * This method is responsible for validating the values passed to the setMealPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMealPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMealPrefForArrayConstraintsFromSetMealPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeMealPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeMealPrefItem instanceof \StructType\MealPrefType) {
                $invalidValues[] = is_object($commonPrefTypeMealPrefItem) ? get_class($commonPrefTypeMealPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeMealPrefItem), var_export($commonPrefTypeMealPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MealPref property can only contain items of type \StructType\MealPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MealPref value
     * @throws \InvalidArgumentException
     * @param \StructType\MealPrefType[] $mealPref
     * @return \StructType\CommonPrefType
     */
    public function setMealPref(array $mealPref = array())
    {
        // validation for constraint: array
        if ('' !== ($mealPrefArrayErrorMessage = self::validateMealPrefForArrayConstraintsFromSetMealPref($mealPref))) {
            throw new \InvalidArgumentException($mealPrefArrayErrorMessage, __LINE__);
        }
        $this->MealPref = $mealPref;
        return $this;
    }
    /**
     * Add item to MealPref value
     * @throws \InvalidArgumentException
     * @param \StructType\MealPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToMealPref(\StructType\MealPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MealPrefType) {
            throw new \InvalidArgumentException(sprintf('The MealPref property can only contain items of type \StructType\MealPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MealPref[] = $item;
        return $this;
    }
    /**
     * Get LoyaltyPref value
     * @return \StructType\LoyaltyPrefType[]|null
     */
    public function getLoyaltyPref()
    {
        return $this->LoyaltyPref;
    }
    /**
     * This method is responsible for validating the values passed to the setLoyaltyPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLoyaltyPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLoyaltyPrefForArrayConstraintsFromSetLoyaltyPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeLoyaltyPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeLoyaltyPrefItem instanceof \StructType\LoyaltyPrefType) {
                $invalidValues[] = is_object($commonPrefTypeLoyaltyPrefItem) ? get_class($commonPrefTypeLoyaltyPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeLoyaltyPrefItem), var_export($commonPrefTypeLoyaltyPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LoyaltyPref property can only contain items of type \StructType\LoyaltyPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LoyaltyPref value
     * @throws \InvalidArgumentException
     * @param \StructType\LoyaltyPrefType[] $loyaltyPref
     * @return \StructType\CommonPrefType
     */
    public function setLoyaltyPref(array $loyaltyPref = array())
    {
        // validation for constraint: array
        if ('' !== ($loyaltyPrefArrayErrorMessage = self::validateLoyaltyPrefForArrayConstraintsFromSetLoyaltyPref($loyaltyPref))) {
            throw new \InvalidArgumentException($loyaltyPrefArrayErrorMessage, __LINE__);
        }
        $this->LoyaltyPref = $loyaltyPref;
        return $this;
    }
    /**
     * Add item to LoyaltyPref value
     * @throws \InvalidArgumentException
     * @param \StructType\LoyaltyPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToLoyaltyPref(\StructType\LoyaltyPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LoyaltyPrefType) {
            throw new \InvalidArgumentException(sprintf('The LoyaltyPref property can only contain items of type \StructType\LoyaltyPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LoyaltyPref[] = $item;
        return $this;
    }
    /**
     * Get SpecRequestPref value
     * @return \StructType\SpecRequestPrefType[]|null
     */
    public function getSpecRequestPref()
    {
        return $this->SpecRequestPref;
    }
    /**
     * This method is responsible for validating the values passed to the setSpecRequestPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSpecRequestPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSpecRequestPrefForArrayConstraintsFromSetSpecRequestPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeSpecRequestPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeSpecRequestPrefItem instanceof \StructType\SpecRequestPrefType) {
                $invalidValues[] = is_object($commonPrefTypeSpecRequestPrefItem) ? get_class($commonPrefTypeSpecRequestPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeSpecRequestPrefItem), var_export($commonPrefTypeSpecRequestPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SpecRequestPref property can only contain items of type \StructType\SpecRequestPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SpecRequestPref value
     * @throws \InvalidArgumentException
     * @param \StructType\SpecRequestPrefType[] $specRequestPref
     * @return \StructType\CommonPrefType
     */
    public function setSpecRequestPref(array $specRequestPref = array())
    {
        // validation for constraint: array
        if ('' !== ($specRequestPrefArrayErrorMessage = self::validateSpecRequestPrefForArrayConstraintsFromSetSpecRequestPref($specRequestPref))) {
            throw new \InvalidArgumentException($specRequestPrefArrayErrorMessage, __LINE__);
        }
        $this->SpecRequestPref = $specRequestPref;
        return $this;
    }
    /**
     * Add item to SpecRequestPref value
     * @throws \InvalidArgumentException
     * @param \StructType\SpecRequestPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToSpecRequestPref(\StructType\SpecRequestPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SpecRequestPrefType) {
            throw new \InvalidArgumentException(sprintf('The SpecRequestPref property can only contain items of type \StructType\SpecRequestPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SpecRequestPref[] = $item;
        return $this;
    }
    /**
     * Get RelatedTravelerPref value
     * @return \StructType\RelatedTravelerPrefType[]|null
     */
    public function getRelatedTravelerPref()
    {
        return $this->RelatedTravelerPref;
    }
    /**
     * This method is responsible for validating the values passed to the setRelatedTravelerPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRelatedTravelerPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRelatedTravelerPrefForArrayConstraintsFromSetRelatedTravelerPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeRelatedTravelerPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeRelatedTravelerPrefItem instanceof \StructType\RelatedTravelerPrefType) {
                $invalidValues[] = is_object($commonPrefTypeRelatedTravelerPrefItem) ? get_class($commonPrefTypeRelatedTravelerPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeRelatedTravelerPrefItem), var_export($commonPrefTypeRelatedTravelerPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RelatedTravelerPref property can only contain items of type \StructType\RelatedTravelerPrefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RelatedTravelerPref value
     * @throws \InvalidArgumentException
     * @param \StructType\RelatedTravelerPrefType[] $relatedTravelerPref
     * @return \StructType\CommonPrefType
     */
    public function setRelatedTravelerPref(array $relatedTravelerPref = array())
    {
        // validation for constraint: array
        if ('' !== ($relatedTravelerPrefArrayErrorMessage = self::validateRelatedTravelerPrefForArrayConstraintsFromSetRelatedTravelerPref($relatedTravelerPref))) {
            throw new \InvalidArgumentException($relatedTravelerPrefArrayErrorMessage, __LINE__);
        }
        $this->RelatedTravelerPref = $relatedTravelerPref;
        return $this;
    }
    /**
     * Add item to RelatedTravelerPref value
     * @throws \InvalidArgumentException
     * @param \StructType\RelatedTravelerPrefType $item
     * @return \StructType\CommonPrefType
     */
    public function addToRelatedTravelerPref(\StructType\RelatedTravelerPrefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RelatedTravelerPrefType) {
            throw new \InvalidArgumentException(sprintf('The RelatedTravelerPref property can only contain items of type \StructType\RelatedTravelerPrefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RelatedTravelerPref[] = $item;
        return $this;
    }
    /**
     * Get ContactPref value
     * @return \StructType\ContactPref[]|null
     */
    public function getContactPref()
    {
        return $this->ContactPref;
    }
    /**
     * This method is responsible for validating the values passed to the setContactPref method
     * This method is willingly generated in order to preserve the one-line inline validation within the setContactPref method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateContactPrefForArrayConstraintsFromSetContactPref(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $commonPrefTypeContactPrefItem) {
            // validation for constraint: itemType
            if (!$commonPrefTypeContactPrefItem instanceof \StructType\ContactPref) {
                $invalidValues[] = is_object($commonPrefTypeContactPrefItem) ? get_class($commonPrefTypeContactPrefItem) : sprintf('%s(%s)', gettype($commonPrefTypeContactPrefItem), var_export($commonPrefTypeContactPrefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ContactPref property can only contain items of type \StructType\ContactPref, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ContactPref value
     * @throws \InvalidArgumentException
     * @param \StructType\ContactPref[] $contactPref
     * @return \StructType\CommonPrefType
     */
    public function setContactPref(array $contactPref = array())
    {
        // validation for constraint: array
        if ('' !== ($contactPrefArrayErrorMessage = self::validateContactPrefForArrayConstraintsFromSetContactPref($contactPref))) {
            throw new \InvalidArgumentException($contactPrefArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(99)
        if (is_array($contactPref) && count($contactPref) > 99) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 99', count($contactPref)), __LINE__);
        }
        $this->ContactPref = $contactPref;
        return $this;
    }
    /**
     * Add item to ContactPref value
     * @throws \InvalidArgumentException
     * @param \StructType\ContactPref $item
     * @return \StructType\CommonPrefType
     */
    public function addToContactPref(\StructType\ContactPref $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ContactPref) {
            throw new \InvalidArgumentException(sprintf('The ContactPref property can only contain items of type \StructType\ContactPref, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(99)
        if (is_array($this->ContactPref) && count($this->ContactPref) >= 99) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 99', count($this->ContactPref)), __LINE__);
        }
        $this->ContactPref[] = $item;
        return $this;
    }
    /**
     * Get EmployeeLevelInfo value
     * @return \StructType\EmployeeInfoType|null
     */
    public function getEmployeeLevelInfo()
    {
        return $this->EmployeeLevelInfo;
    }
    /**
     * Set EmployeeLevelInfo value
     * @param \StructType\EmployeeInfoType $employeeLevelInfo
     * @return \StructType\CommonPrefType
     */
    public function setEmployeeLevelInfo(\StructType\EmployeeInfoType $employeeLevelInfo = null)
    {
        $this->EmployeeLevelInfo = $employeeLevelInfo;
        return $this;
    }
    /**
     * Get TPA_Extensions value
     * @return \StructType\TPA_ExtensionsType|null
     */
    public function getTPA_Extensions()
    {
        return $this->TPA_Extensions;
    }
    /**
     * Set TPA_Extensions value
     * @param \StructType\TPA_ExtensionsType $tPA_Extensions
     * @return \StructType\CommonPrefType
     */
    public function setTPA_Extensions(\StructType\TPA_ExtensionsType $tPA_Extensions = null)
    {
        $this->TPA_Extensions = $tPA_Extensions;
        return $this;
    }
    /**
     * Get ShareSynchInd value
     * @return string|null
     */
    public function getShareSynchInd()
    {
        return $this->ShareSynchInd;
    }
    /**
     * Set ShareSynchInd value
     * @param string $shareSynchInd
     * @return \StructType\CommonPrefType
     */
    public function setShareSynchInd($shareSynchInd = null)
    {
        // validation for constraint: string
        if (!is_null($shareSynchInd) && !is_string($shareSynchInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shareSynchInd, true), gettype($shareSynchInd)), __LINE__);
        }
        $this->ShareSynchInd = $shareSynchInd;
        return $this;
    }
    /**
     * Get ShareMarketInd value
     * @return string|null
     */
    public function getShareMarketInd()
    {
        return $this->ShareMarketInd;
    }
    /**
     * Set ShareMarketInd value
     * @param string $shareMarketInd
     * @return \StructType\CommonPrefType
     */
    public function setShareMarketInd($shareMarketInd = null)
    {
        // validation for constraint: string
        if (!is_null($shareMarketInd) && !is_string($shareMarketInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shareMarketInd, true), gettype($shareMarketInd)), __LINE__);
        }
        $this->ShareMarketInd = $shareMarketInd;
        return $this;
    }
    /**
     * Get SmokingAllowed value
     * @return bool|null
     */
    public function getSmokingAllowed()
    {
        return $this->SmokingAllowed;
    }
    /**
     * Set SmokingAllowed value
     * @param bool $smokingAllowed
     * @return \StructType\CommonPrefType
     */
    public function setSmokingAllowed($smokingAllowed = null)
    {
        // validation for constraint: boolean
        if (!is_null($smokingAllowed) && !is_bool($smokingAllowed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($smokingAllowed, true), gettype($smokingAllowed)), __LINE__);
        }
        $this->SmokingAllowed = $smokingAllowed;
        return $this;
    }
    /**
     * Get PrimaryLangID value
     * @return string|null
     */
    public function getPrimaryLangID()
    {
        return $this->PrimaryLangID;
    }
    /**
     * Set PrimaryLangID value
     * @param string $primaryLangID
     * @return \StructType\CommonPrefType
     */
    public function setPrimaryLangID($primaryLangID = null)
    {
        // validation for constraint: string
        if (!is_null($primaryLangID) && !is_string($primaryLangID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryLangID, true), gettype($primaryLangID)), __LINE__);
        }
        $this->PrimaryLangID = $primaryLangID;
        return $this;
    }
    /**
     * Get AltLangID value
     * @return string|null
     */
    public function getAltLangID()
    {
        return $this->AltLangID;
    }
    /**
     * Set AltLangID value
     * @param string $altLangID
     * @return \StructType\CommonPrefType
     */
    public function setAltLangID($altLangID = null)
    {
        // validation for constraint: string
        if (!is_null($altLangID) && !is_string($altLangID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($altLangID, true), gettype($altLangID)), __LINE__);
        }
        $this->AltLangID = $altLangID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CommonPrefType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
