<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CountCategorySummaries StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of CountCategorySummaryType elements. | Collection of CountCategorySummary elements. Used if count values reported.
 * @subpackage Structs
 */
class CountCategorySummaries extends AbstractStructBase
{
    /**
     * The CountCategorySummary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\CountCategorySummary[]
     */
    public $CountCategorySummary;
    /**
     * Constructor method for CountCategorySummaries
     * @uses CountCategorySummaries::setCountCategorySummary()
     * @param \StructType\CountCategorySummary[] $countCategorySummary
     */
    public function __construct(array $countCategorySummary = array())
    {
        $this
            ->setCountCategorySummary($countCategorySummary);
    }
    /**
     * Get CountCategorySummary value
     * @return \StructType\CountCategorySummary[]|null
     */
    public function getCountCategorySummary()
    {
        return $this->CountCategorySummary;
    }
    /**
     * This method is responsible for validating the values passed to the setCountCategorySummary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCountCategorySummary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCountCategorySummaryForArrayConstraintsFromSetCountCategorySummary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $countCategorySummariesCountCategorySummaryItem) {
            // validation for constraint: itemType
            if (!$countCategorySummariesCountCategorySummaryItem instanceof \StructType\CountCategorySummary) {
                $invalidValues[] = is_object($countCategorySummariesCountCategorySummaryItem) ? get_class($countCategorySummariesCountCategorySummaryItem) : sprintf('%s(%s)', gettype($countCategorySummariesCountCategorySummaryItem), var_export($countCategorySummariesCountCategorySummaryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CountCategorySummary property can only contain items of type \StructType\CountCategorySummary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CountCategorySummary value
     * @throws \InvalidArgumentException
     * @param \StructType\CountCategorySummary[] $countCategorySummary
     * @return \StructType\CountCategorySummaries
     */
    public function setCountCategorySummary(array $countCategorySummary = array())
    {
        // validation for constraint: array
        if ('' !== ($countCategorySummaryArrayErrorMessage = self::validateCountCategorySummaryForArrayConstraintsFromSetCountCategorySummary($countCategorySummary))) {
            throw new \InvalidArgumentException($countCategorySummaryArrayErrorMessage, __LINE__);
        }
        $this->CountCategorySummary = $countCategorySummary;
        return $this;
    }
    /**
     * Add item to CountCategorySummary value
     * @throws \InvalidArgumentException
     * @param \StructType\CountCategorySummary $item
     * @return \StructType\CountCategorySummaries
     */
    public function addToCountCategorySummary(\StructType\CountCategorySummary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CountCategorySummary) {
            throw new \InvalidArgumentException(sprintf('The CountCategorySummary property can only contain items of type \StructType\CountCategorySummary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CountCategorySummary[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CountCategorySummaries
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
