<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GDS_CodeDetails StructType
 * Meta information extracted from the WSDL
 * - documentation: Collection of GDS_CodeDetails.
 * @subpackage Structs
 */
class GDS_CodeDetails extends AbstractStructBase
{
    /**
     * The GDS_CodeDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GDS_CodeDetail[]
     */
    public $GDS_CodeDetail;
    /**
     * Constructor method for GDS_CodeDetails
     * @uses GDS_CodeDetails::setGDS_CodeDetail()
     * @param \StructType\GDS_CodeDetail[] $gDS_CodeDetail
     */
    public function __construct(array $gDS_CodeDetail = array())
    {
        $this
            ->setGDS_CodeDetail($gDS_CodeDetail);
    }
    /**
     * Get GDS_CodeDetail value
     * @return \StructType\GDS_CodeDetail[]|null
     */
    public function getGDS_CodeDetail()
    {
        return $this->GDS_CodeDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setGDS_CodeDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGDS_CodeDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGDS_CodeDetailForArrayConstraintsFromSetGDS_CodeDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $gDS_CodeDetailsGDS_CodeDetailItem) {
            // validation for constraint: itemType
            if (!$gDS_CodeDetailsGDS_CodeDetailItem instanceof \StructType\GDS_CodeDetail) {
                $invalidValues[] = is_object($gDS_CodeDetailsGDS_CodeDetailItem) ? get_class($gDS_CodeDetailsGDS_CodeDetailItem) : sprintf('%s(%s)', gettype($gDS_CodeDetailsGDS_CodeDetailItem), var_export($gDS_CodeDetailsGDS_CodeDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GDS_CodeDetail property can only contain items of type \StructType\GDS_CodeDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GDS_CodeDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\GDS_CodeDetail[] $gDS_CodeDetail
     * @return \StructType\GDS_CodeDetails
     */
    public function setGDS_CodeDetail(array $gDS_CodeDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($gDS_CodeDetailArrayErrorMessage = self::validateGDS_CodeDetailForArrayConstraintsFromSetGDS_CodeDetail($gDS_CodeDetail))) {
            throw new \InvalidArgumentException($gDS_CodeDetailArrayErrorMessage, __LINE__);
        }
        $this->GDS_CodeDetail = $gDS_CodeDetail;
        return $this;
    }
    /**
     * Add item to GDS_CodeDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\GDS_CodeDetail $item
     * @return \StructType\GDS_CodeDetails
     */
    public function addToGDS_CodeDetail(\StructType\GDS_CodeDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GDS_CodeDetail) {
            throw new \InvalidArgumentException(sprintf('The GDS_CodeDetail property can only contain items of type \StructType\GDS_CodeDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GDS_CodeDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GDS_CodeDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
