<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GuaranteesAccepted StructType
 * @subpackage Structs
 */
class GuaranteesAccepted extends AbstractStructBase
{
    /**
     * The GuaranteeAccepted
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\GuaranteeAccepted[]
     */
    public $GuaranteeAccepted;
    /**
     * Constructor method for GuaranteesAccepted
     * @uses GuaranteesAccepted::setGuaranteeAccepted()
     * @param \StructType\GuaranteeAccepted[] $guaranteeAccepted
     */
    public function __construct(array $guaranteeAccepted = array())
    {
        $this
            ->setGuaranteeAccepted($guaranteeAccepted);
    }
    /**
     * Get GuaranteeAccepted value
     * @return \StructType\GuaranteeAccepted[]|null
     */
    public function getGuaranteeAccepted()
    {
        return $this->GuaranteeAccepted;
    }
    /**
     * This method is responsible for validating the values passed to the setGuaranteeAccepted method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuaranteeAccepted method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuaranteeAcceptedForArrayConstraintsFromSetGuaranteeAccepted(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $guaranteesAcceptedGuaranteeAcceptedItem) {
            // validation for constraint: itemType
            if (!$guaranteesAcceptedGuaranteeAcceptedItem instanceof \StructType\GuaranteeAccepted) {
                $invalidValues[] = is_object($guaranteesAcceptedGuaranteeAcceptedItem) ? get_class($guaranteesAcceptedGuaranteeAcceptedItem) : sprintf('%s(%s)', gettype($guaranteesAcceptedGuaranteeAcceptedItem), var_export($guaranteesAcceptedGuaranteeAcceptedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GuaranteeAccepted property can only contain items of type \StructType\GuaranteeAccepted, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GuaranteeAccepted value
     * @throws \InvalidArgumentException
     * @param \StructType\GuaranteeAccepted[] $guaranteeAccepted
     * @return \StructType\GuaranteesAccepted
     */
    public function setGuaranteeAccepted(array $guaranteeAccepted = array())
    {
        // validation for constraint: array
        if ('' !== ($guaranteeAcceptedArrayErrorMessage = self::validateGuaranteeAcceptedForArrayConstraintsFromSetGuaranteeAccepted($guaranteeAccepted))) {
            throw new \InvalidArgumentException($guaranteeAcceptedArrayErrorMessage, __LINE__);
        }
        $this->GuaranteeAccepted = $guaranteeAccepted;
        return $this;
    }
    /**
     * Add item to GuaranteeAccepted value
     * @throws \InvalidArgumentException
     * @param \StructType\GuaranteeAccepted $item
     * @return \StructType\GuaranteesAccepted
     */
    public function addToGuaranteeAccepted(\StructType\GuaranteeAccepted $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GuaranteeAccepted) {
            throw new \InvalidArgumentException(sprintf('The GuaranteeAccepted property can only contain items of type \StructType\GuaranteeAccepted, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GuaranteeAccepted[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GuaranteesAccepted
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
