<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelStays StructType
 * @subpackage Structs
 */
class HotelStays extends AbstractStructBase
{
    /**
     * The HotelStay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\HotelStay[]
     */
    public $HotelStay;
    /**
     * Constructor method for HotelStays
     * @uses HotelStays::setHotelStay()
     * @param \StructType\HotelStay[] $hotelStay
     */
    public function __construct(array $hotelStay = array())
    {
        $this
            ->setHotelStay($hotelStay);
    }
    /**
     * Get HotelStay value
     * @return \StructType\HotelStay[]|null
     */
    public function getHotelStay()
    {
        return $this->HotelStay;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelStay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelStay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelStayForArrayConstraintsFromSetHotelStay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $hotelStaysHotelStayItem) {
            // validation for constraint: itemType
            if (!$hotelStaysHotelStayItem instanceof \StructType\HotelStay) {
                $invalidValues[] = is_object($hotelStaysHotelStayItem) ? get_class($hotelStaysHotelStayItem) : sprintf('%s(%s)', gettype($hotelStaysHotelStayItem), var_export($hotelStaysHotelStayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelStay property can only contain items of type \StructType\HotelStay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelStay value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelStay[] $hotelStay
     * @return \StructType\HotelStays
     */
    public function setHotelStay(array $hotelStay = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelStayArrayErrorMessage = self::validateHotelStayForArrayConstraintsFromSetHotelStay($hotelStay))) {
            throw new \InvalidArgumentException($hotelStayArrayErrorMessage, __LINE__);
        }
        $this->HotelStay = $hotelStay;
        return $this;
    }
    /**
     * Add item to HotelStay value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelStay $item
     * @return \StructType\HotelStays
     */
    public function addToHotelStay(\StructType\HotelStay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelStay) {
            throw new \InvalidArgumentException(sprintf('The HotelStay property can only contain items of type \StructType\HotelStay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelStay[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HotelStays
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
