<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OffSell StructType
 * Meta information extracted from the WSDL
 * - documentation: Communicates information about inventory that is not available for sale. | Communicates additional information about inventory that is not available for sale.
 * @subpackage Structs
 */
class OffSell extends AbstractStructBase
{
    /**
     * The OffSellValueType
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $OffSellValueType;
    /**
     * The OffSellValue
     * Meta information extracted from the WSDL
     * - documentation: Specifies an amount, max 3 decimals.
     * - base: xs:decimal
     * - fractionDigits: 3
     * - use: optional
     * @var float
     */
    public $OffSellValue;
    /**
     * Constructor method for OffSell
     * @uses OffSell::setOffSellValueType()
     * @uses OffSell::setOffSellValue()
     * @param string $offSellValueType
     * @param float $offSellValue
     */
    public function __construct($offSellValueType = null, $offSellValue = null)
    {
        $this
            ->setOffSellValueType($offSellValueType)
            ->setOffSellValue($offSellValue);
    }
    /**
     * Get OffSellValueType value
     * @return string|null
     */
    public function getOffSellValueType()
    {
        return $this->OffSellValueType;
    }
    /**
     * Set OffSellValueType value
     * @param string $offSellValueType
     * @return \StructType\OffSell
     */
    public function setOffSellValueType($offSellValueType = null)
    {
        // validation for constraint: string
        if (!is_null($offSellValueType) && !is_string($offSellValueType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($offSellValueType, true), gettype($offSellValueType)), __LINE__);
        }
        $this->OffSellValueType = $offSellValueType;
        return $this;
    }
    /**
     * Get OffSellValue value
     * @return float|null
     */
    public function getOffSellValue()
    {
        return $this->OffSellValue;
    }
    /**
     * Set OffSellValue value
     * @param float $offSellValue
     * @return \StructType\OffSell
     */
    public function setOffSellValue($offSellValue = null)
    {
        // validation for constraint: float
        if (!is_null($offSellValue) && !(is_float($offSellValue) || is_numeric($offSellValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($offSellValue, true), gettype($offSellValue)), __LINE__);
        }
        // validation for constraint: fractionDigits(3)
        if (!is_null($offSellValue) && mb_strlen(mb_substr($offSellValue, mb_strpos($offSellValue, '.') + 1)) > 3) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must at most contain 3 fraction digits, %d given', var_export($offSellValue, true), mb_strlen(mb_substr($offSellValue, mb_strpos($offSellValue, '.') + 1))), __LINE__);
        }
        $this->OffSellValue = $offSellValue;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OffSell
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
