<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OperationTimes StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of OperationTimes.
 * @subpackage Structs
 */
class OperationTimes extends AbstractStructBase
{
    /**
     * The OperationTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 999
     * @var \StructType\OperationTime[]
     */
    public $OperationTime;
    /**
     * Constructor method for OperationTimes
     * @uses OperationTimes::setOperationTime()
     * @param \StructType\OperationTime[] $operationTime
     */
    public function __construct(array $operationTime = array())
    {
        $this
            ->setOperationTime($operationTime);
    }
    /**
     * Get OperationTime value
     * @return \StructType\OperationTime[]|null
     */
    public function getOperationTime()
    {
        return $this->OperationTime;
    }
    /**
     * This method is responsible for validating the values passed to the setOperationTime method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOperationTime method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOperationTimeForArrayConstraintsFromSetOperationTime(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $operationTimesOperationTimeItem) {
            // validation for constraint: itemType
            if (!$operationTimesOperationTimeItem instanceof \StructType\OperationTime) {
                $invalidValues[] = is_object($operationTimesOperationTimeItem) ? get_class($operationTimesOperationTimeItem) : sprintf('%s(%s)', gettype($operationTimesOperationTimeItem), var_export($operationTimesOperationTimeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OperationTime property can only contain items of type \StructType\OperationTime, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OperationTime value
     * @throws \InvalidArgumentException
     * @param \StructType\OperationTime[] $operationTime
     * @return \StructType\OperationTimes
     */
    public function setOperationTime(array $operationTime = array())
    {
        // validation for constraint: array
        if ('' !== ($operationTimeArrayErrorMessage = self::validateOperationTimeForArrayConstraintsFromSetOperationTime($operationTime))) {
            throw new \InvalidArgumentException($operationTimeArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(999)
        if (is_array($operationTime) && count($operationTime) > 999) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 999', count($operationTime)), __LINE__);
        }
        $this->OperationTime = $operationTime;
        return $this;
    }
    /**
     * Add item to OperationTime value
     * @throws \InvalidArgumentException
     * @param \StructType\OperationTime $item
     * @return \StructType\OperationTimes
     */
    public function addToOperationTime(\StructType\OperationTime $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OperationTime) {
            throw new \InvalidArgumentException(sprintf('The OperationTime property can only contain items of type \StructType\OperationTime, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(999)
        if (is_array($this->OperationTime) && count($this->OperationTime) >= 999) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 999', count($this->OperationTime)), __LINE__);
        }
        $this->OperationTime[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OperationTimes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
