<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OriginDestinationOptions StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of OriginDestinationOption
 * @subpackage Structs
 */
class OriginDestinationOptions extends AbstractStructBase
{
    /**
     * The OriginDestinationOption
     * Meta information extracted from the WSDL
     * - maxOccurs: 99
     * @var \StructType\OriginDestinationOption[]
     */
    public $OriginDestinationOption;
    /**
     * Constructor method for OriginDestinationOptions
     * @uses OriginDestinationOptions::setOriginDestinationOption()
     * @param \StructType\OriginDestinationOption[] $originDestinationOption
     */
    public function __construct(array $originDestinationOption = array())
    {
        $this
            ->setOriginDestinationOption($originDestinationOption);
    }
    /**
     * Get OriginDestinationOption value
     * @return \StructType\OriginDestinationOption[]|null
     */
    public function getOriginDestinationOption()
    {
        return $this->OriginDestinationOption;
    }
    /**
     * This method is responsible for validating the values passed to the setOriginDestinationOption method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOriginDestinationOption method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOriginDestinationOptionForArrayConstraintsFromSetOriginDestinationOption(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $originDestinationOptionsOriginDestinationOptionItem) {
            // validation for constraint: itemType
            if (!$originDestinationOptionsOriginDestinationOptionItem instanceof \StructType\OriginDestinationOption) {
                $invalidValues[] = is_object($originDestinationOptionsOriginDestinationOptionItem) ? get_class($originDestinationOptionsOriginDestinationOptionItem) : sprintf('%s(%s)', gettype($originDestinationOptionsOriginDestinationOptionItem), var_export($originDestinationOptionsOriginDestinationOptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OriginDestinationOption property can only contain items of type \StructType\OriginDestinationOption, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OriginDestinationOption value
     * @throws \InvalidArgumentException
     * @param \StructType\OriginDestinationOption[] $originDestinationOption
     * @return \StructType\OriginDestinationOptions
     */
    public function setOriginDestinationOption(array $originDestinationOption = array())
    {
        // validation for constraint: array
        if ('' !== ($originDestinationOptionArrayErrorMessage = self::validateOriginDestinationOptionForArrayConstraintsFromSetOriginDestinationOption($originDestinationOption))) {
            throw new \InvalidArgumentException($originDestinationOptionArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(99)
        if (is_array($originDestinationOption) && count($originDestinationOption) > 99) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 99', count($originDestinationOption)), __LINE__);
        }
        $this->OriginDestinationOption = $originDestinationOption;
        return $this;
    }
    /**
     * Add item to OriginDestinationOption value
     * @throws \InvalidArgumentException
     * @param \StructType\OriginDestinationOption $item
     * @return \StructType\OriginDestinationOptions
     */
    public function addToOriginDestinationOption(\StructType\OriginDestinationOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OriginDestinationOption) {
            throw new \InvalidArgumentException(sprintf('The OriginDestinationOption property can only contain items of type \StructType\OriginDestinationOption, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(99)
        if (is_array($this->OriginDestinationOption) && count($this->OriginDestinationOption) >= 99) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 99', count($this->OriginDestinationOption)), __LINE__);
        }
        $this->OriginDestinationOption[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OriginDestinationOptions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
