<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PricedItinerariesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Container for priced itineraries.
 * @subpackage Structs
 */
class PricedItinerariesType extends AbstractStructBase
{
    /**
     * The PricedItinerary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\PricedItinerary[]
     */
    public $PricedItinerary;
    /**
     * Constructor method for PricedItinerariesType
     * @uses PricedItinerariesType::setPricedItinerary()
     * @param \StructType\PricedItinerary[] $pricedItinerary
     */
    public function __construct(array $pricedItinerary = array())
    {
        $this
            ->setPricedItinerary($pricedItinerary);
    }
    /**
     * Get PricedItinerary value
     * @return \StructType\PricedItinerary[]|null
     */
    public function getPricedItinerary()
    {
        return $this->PricedItinerary;
    }
    /**
     * This method is responsible for validating the values passed to the setPricedItinerary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPricedItinerary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePricedItineraryForArrayConstraintsFromSetPricedItinerary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pricedItinerariesTypePricedItineraryItem) {
            // validation for constraint: itemType
            if (!$pricedItinerariesTypePricedItineraryItem instanceof \StructType\PricedItinerary) {
                $invalidValues[] = is_object($pricedItinerariesTypePricedItineraryItem) ? get_class($pricedItinerariesTypePricedItineraryItem) : sprintf('%s(%s)', gettype($pricedItinerariesTypePricedItineraryItem), var_export($pricedItinerariesTypePricedItineraryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PricedItinerary property can only contain items of type \StructType\PricedItinerary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PricedItinerary value
     * @throws \InvalidArgumentException
     * @param \StructType\PricedItinerary[] $pricedItinerary
     * @return \StructType\PricedItinerariesType
     */
    public function setPricedItinerary(array $pricedItinerary = array())
    {
        // validation for constraint: array
        if ('' !== ($pricedItineraryArrayErrorMessage = self::validatePricedItineraryForArrayConstraintsFromSetPricedItinerary($pricedItinerary))) {
            throw new \InvalidArgumentException($pricedItineraryArrayErrorMessage, __LINE__);
        }
        $this->PricedItinerary = $pricedItinerary;
        return $this;
    }
    /**
     * Add item to PricedItinerary value
     * @throws \InvalidArgumentException
     * @param \StructType\PricedItinerary $item
     * @return \StructType\PricedItinerariesType
     */
    public function addToPricedItinerary(\StructType\PricedItinerary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PricedItinerary) {
            throw new \InvalidArgumentException(sprintf('The PricedItinerary property can only contain items of type \StructType\PricedItinerary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PricedItinerary[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PricedItinerariesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
