<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProfileRPHs StructType
 * Meta information extracted from the WSDL
 * - documentation: Collection of ProfileRPH.
 * @subpackage Structs
 */
class ProfileRPHs extends AbstractStructBase
{
    /**
     * The ProfileRPH
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ProfileRPH[]
     */
    public $ProfileRPH;
    /**
     * Constructor method for ProfileRPHs
     * @uses ProfileRPHs::setProfileRPH()
     * @param \StructType\ProfileRPH[] $profileRPH
     */
    public function __construct(array $profileRPH = array())
    {
        $this
            ->setProfileRPH($profileRPH);
    }
    /**
     * Get ProfileRPH value
     * @return \StructType\ProfileRPH[]|null
     */
    public function getProfileRPH()
    {
        return $this->ProfileRPH;
    }
    /**
     * This method is responsible for validating the values passed to the setProfileRPH method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProfileRPH method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProfileRPHForArrayConstraintsFromSetProfileRPH(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $profileRPHsProfileRPHItem) {
            // validation for constraint: itemType
            if (!$profileRPHsProfileRPHItem instanceof \StructType\ProfileRPH) {
                $invalidValues[] = is_object($profileRPHsProfileRPHItem) ? get_class($profileRPHsProfileRPHItem) : sprintf('%s(%s)', gettype($profileRPHsProfileRPHItem), var_export($profileRPHsProfileRPHItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProfileRPH property can only contain items of type \StructType\ProfileRPH, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProfileRPH value
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileRPH[] $profileRPH
     * @return \StructType\ProfileRPHs
     */
    public function setProfileRPH(array $profileRPH = array())
    {
        // validation for constraint: array
        if ('' !== ($profileRPHArrayErrorMessage = self::validateProfileRPHForArrayConstraintsFromSetProfileRPH($profileRPH))) {
            throw new \InvalidArgumentException($profileRPHArrayErrorMessage, __LINE__);
        }
        $this->ProfileRPH = $profileRPH;
        return $this;
    }
    /**
     * Add item to ProfileRPH value
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileRPH $item
     * @return \StructType\ProfileRPHs
     */
    public function addToProfileRPH(\StructType\ProfileRPH $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProfileRPH) {
            throw new \InvalidArgumentException(sprintf('The ProfileRPH property can only contain items of type \StructType\ProfileRPH, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProfileRPH[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProfileRPHs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
