<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProfileRef StructType
 * Meta information extracted from the WSDL
 * - documentation: Stored information about a customer. May contain readily available information relevant to the booking.
 * @subpackage Structs
 */
class ProfileRef extends AbstractStructBase
{
    /**
     * The UniqueID
     * Meta information extracted from the WSDL
     * - documentation: An identifier used to uniquely reference a customer profile.
     * @var \StructType\UniqueID_Type
     */
    public $UniqueID;
    /**
     * Constructor method for ProfileRef
     * @uses ProfileRef::setUniqueID()
     * @param \StructType\UniqueID_Type $uniqueID
     */
    public function __construct(\StructType\UniqueID_Type $uniqueID = null)
    {
        $this
            ->setUniqueID($uniqueID);
    }
    /**
     * Get UniqueID value
     * @return \StructType\UniqueID_Type|null
     */
    public function getUniqueID()
    {
        return $this->UniqueID;
    }
    /**
     * Set UniqueID value
     * @param \StructType\UniqueID_Type $uniqueID
     * @return \StructType\ProfileRef
     */
    public function setUniqueID(\StructType\UniqueID_Type $uniqueID = null)
    {
        $this->UniqueID = $uniqueID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProfileRef
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
