<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RatePlanCandidatesType StructType
 * @subpackage Structs
 */
class RatePlanCandidatesType extends AbstractStructBase
{
    /**
     * The RatePlanCandidate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\RatePlanCandidate[]
     */
    public $RatePlanCandidate;
    /**
     * Constructor method for RatePlanCandidatesType
     * @uses RatePlanCandidatesType::setRatePlanCandidate()
     * @param \StructType\RatePlanCandidate[] $ratePlanCandidate
     */
    public function __construct(array $ratePlanCandidate = array())
    {
        $this
            ->setRatePlanCandidate($ratePlanCandidate);
    }
    /**
     * Get RatePlanCandidate value
     * @return \StructType\RatePlanCandidate[]|null
     */
    public function getRatePlanCandidate()
    {
        return $this->RatePlanCandidate;
    }
    /**
     * This method is responsible for validating the values passed to the setRatePlanCandidate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRatePlanCandidate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRatePlanCandidateForArrayConstraintsFromSetRatePlanCandidate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $ratePlanCandidatesTypeRatePlanCandidateItem) {
            // validation for constraint: itemType
            if (!$ratePlanCandidatesTypeRatePlanCandidateItem instanceof \StructType\RatePlanCandidate) {
                $invalidValues[] = is_object($ratePlanCandidatesTypeRatePlanCandidateItem) ? get_class($ratePlanCandidatesTypeRatePlanCandidateItem) : sprintf('%s(%s)', gettype($ratePlanCandidatesTypeRatePlanCandidateItem), var_export($ratePlanCandidatesTypeRatePlanCandidateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RatePlanCandidate property can only contain items of type \StructType\RatePlanCandidate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RatePlanCandidate value
     * @throws \InvalidArgumentException
     * @param \StructType\RatePlanCandidate[] $ratePlanCandidate
     * @return \StructType\RatePlanCandidatesType
     */
    public function setRatePlanCandidate(array $ratePlanCandidate = array())
    {
        // validation for constraint: array
        if ('' !== ($ratePlanCandidateArrayErrorMessage = self::validateRatePlanCandidateForArrayConstraintsFromSetRatePlanCandidate($ratePlanCandidate))) {
            throw new \InvalidArgumentException($ratePlanCandidateArrayErrorMessage, __LINE__);
        }
        $this->RatePlanCandidate = $ratePlanCandidate;
        return $this;
    }
    /**
     * Add item to RatePlanCandidate value
     * @throws \InvalidArgumentException
     * @param \StructType\RatePlanCandidate $item
     * @return \StructType\RatePlanCandidatesType
     */
    public function addToRatePlanCandidate(\StructType\RatePlanCandidate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RatePlanCandidate) {
            throw new \InvalidArgumentException(sprintf('The RatePlanCandidate property can only contain items of type \StructType\RatePlanCandidate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RatePlanCandidate[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RatePlanCandidatesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
