<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RatePlans StructType
 * Meta information extracted from the WSDL
 * - documentation: The rate plan element is used to contain all the rate information for a single Rate Plan Code (ex RACK) for a given date range. A given Rate Plan may have variable rates, over the effective period of the Rate Plan, this is
 * represented by the child element Rates. | A collection of Rate Plans associated with a particular Room Stay. | Rate Plan info. | This allows for multiple rate plans for a specific room type.
 * @subpackage Structs
 */
class RatePlans extends AbstractStructBase
{
    /**
     * The RatePlan
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\RatePlan[]
     */
    public $RatePlan;
    /**
     * Constructor method for RatePlans
     * @uses RatePlans::setRatePlan()
     * @param \StructType\RatePlan[] $ratePlan
     */
    public function __construct(array $ratePlan = array())
    {
        $this
            ->setRatePlan($ratePlan);
    }
    /**
     * Get RatePlan value
     * @return \StructType\RatePlan[]|null
     */
    public function getRatePlan()
    {
        return $this->RatePlan;
    }
    /**
     * This method is responsible for validating the values passed to the setRatePlan method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRatePlan method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRatePlanForArrayConstraintsFromSetRatePlan(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $ratePlansRatePlanItem) {
            // validation for constraint: itemType
            if (!$ratePlansRatePlanItem instanceof \StructType\RatePlan) {
                $invalidValues[] = is_object($ratePlansRatePlanItem) ? get_class($ratePlansRatePlanItem) : sprintf('%s(%s)', gettype($ratePlansRatePlanItem), var_export($ratePlansRatePlanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RatePlan property can only contain items of type \StructType\RatePlan, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RatePlan value
     * @throws \InvalidArgumentException
     * @param \StructType\RatePlan[] $ratePlan
     * @return \StructType\RatePlans
     */
    public function setRatePlan(array $ratePlan = array())
    {
        // validation for constraint: array
        if ('' !== ($ratePlanArrayErrorMessage = self::validateRatePlanForArrayConstraintsFromSetRatePlan($ratePlan))) {
            throw new \InvalidArgumentException($ratePlanArrayErrorMessage, __LINE__);
        }
        $this->RatePlan = $ratePlan;
        return $this;
    }
    /**
     * Add item to RatePlan value
     * @throws \InvalidArgumentException
     * @param \StructType\RatePlan $item
     * @return \StructType\RatePlans
     */
    public function addToRatePlan(\StructType\RatePlan $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RatePlan) {
            throw new \InvalidArgumentException(sprintf('The RatePlan property can only contain items of type \StructType\RatePlan, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RatePlan[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RatePlans
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
