<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RequiredPaymentsType StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of required payments.
 * @subpackage Structs
 */
class RequiredPaymentsType extends AbstractStructBase
{
    /**
     * The GuaranteePayment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\GuaranteePayment[]
     */
    public $GuaranteePayment;
    /**
     * Constructor method for RequiredPaymentsType
     * @uses RequiredPaymentsType::setGuaranteePayment()
     * @param \StructType\GuaranteePayment[] $guaranteePayment
     */
    public function __construct(array $guaranteePayment = array())
    {
        $this
            ->setGuaranteePayment($guaranteePayment);
    }
    /**
     * Get GuaranteePayment value
     * @return \StructType\GuaranteePayment[]|null
     */
    public function getGuaranteePayment()
    {
        return $this->GuaranteePayment;
    }
    /**
     * This method is responsible for validating the values passed to the setGuaranteePayment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuaranteePayment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuaranteePaymentForArrayConstraintsFromSetGuaranteePayment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $requiredPaymentsTypeGuaranteePaymentItem) {
            // validation for constraint: itemType
            if (!$requiredPaymentsTypeGuaranteePaymentItem instanceof \StructType\GuaranteePayment) {
                $invalidValues[] = is_object($requiredPaymentsTypeGuaranteePaymentItem) ? get_class($requiredPaymentsTypeGuaranteePaymentItem) : sprintf('%s(%s)', gettype($requiredPaymentsTypeGuaranteePaymentItem), var_export($requiredPaymentsTypeGuaranteePaymentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GuaranteePayment property can only contain items of type \StructType\GuaranteePayment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GuaranteePayment value
     * @throws \InvalidArgumentException
     * @param \StructType\GuaranteePayment[] $guaranteePayment
     * @return \StructType\RequiredPaymentsType
     */
    public function setGuaranteePayment(array $guaranteePayment = array())
    {
        // validation for constraint: array
        if ('' !== ($guaranteePaymentArrayErrorMessage = self::validateGuaranteePaymentForArrayConstraintsFromSetGuaranteePayment($guaranteePayment))) {
            throw new \InvalidArgumentException($guaranteePaymentArrayErrorMessage, __LINE__);
        }
        $this->GuaranteePayment = $guaranteePayment;
        return $this;
    }
    /**
     * Add item to GuaranteePayment value
     * @throws \InvalidArgumentException
     * @param \StructType\GuaranteePayment $item
     * @return \StructType\RequiredPaymentsType
     */
    public function addToGuaranteePayment(\StructType\GuaranteePayment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GuaranteePayment) {
            throw new \InvalidArgumentException(sprintf('The GuaranteePayment property can only contain items of type \StructType\GuaranteePayment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GuaranteePayment[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RequiredPaymentsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
