<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResGuestRPHsType StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of unsigned integers serving as reference placeholders, and used as an index identifying which guests occupy this room
 * @subpackage Structs
 */
class ResGuestRPHsType extends AbstractStructBase
{
    /**
     * The ResGuestRPH
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ResGuestRPH[]
     */
    public $ResGuestRPH;
    /**
     * Constructor method for ResGuestRPHsType
     * @uses ResGuestRPHsType::setResGuestRPH()
     * @param \StructType\ResGuestRPH[] $resGuestRPH
     */
    public function __construct(array $resGuestRPH = array())
    {
        $this
            ->setResGuestRPH($resGuestRPH);
    }
    /**
     * Get ResGuestRPH value
     * @return \StructType\ResGuestRPH[]|null
     */
    public function getResGuestRPH()
    {
        return $this->ResGuestRPH;
    }
    /**
     * This method is responsible for validating the values passed to the setResGuestRPH method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResGuestRPH method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResGuestRPHForArrayConstraintsFromSetResGuestRPH(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $resGuestRPHsTypeResGuestRPHItem) {
            // validation for constraint: itemType
            if (!$resGuestRPHsTypeResGuestRPHItem instanceof \StructType\ResGuestRPH) {
                $invalidValues[] = is_object($resGuestRPHsTypeResGuestRPHItem) ? get_class($resGuestRPHsTypeResGuestRPHItem) : sprintf('%s(%s)', gettype($resGuestRPHsTypeResGuestRPHItem), var_export($resGuestRPHsTypeResGuestRPHItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ResGuestRPH property can only contain items of type \StructType\ResGuestRPH, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ResGuestRPH value
     * @throws \InvalidArgumentException
     * @param \StructType\ResGuestRPH[] $resGuestRPH
     * @return \StructType\ResGuestRPHsType
     */
    public function setResGuestRPH(array $resGuestRPH = array())
    {
        // validation for constraint: array
        if ('' !== ($resGuestRPHArrayErrorMessage = self::validateResGuestRPHForArrayConstraintsFromSetResGuestRPH($resGuestRPH))) {
            throw new \InvalidArgumentException($resGuestRPHArrayErrorMessage, __LINE__);
        }
        $this->ResGuestRPH = $resGuestRPH;
        return $this;
    }
    /**
     * Add item to ResGuestRPH value
     * @throws \InvalidArgumentException
     * @param \StructType\ResGuestRPH $item
     * @return \StructType\ResGuestRPHsType
     */
    public function addToResGuestRPH(\StructType\ResGuestRPH $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ResGuestRPH) {
            throw new \InvalidArgumentException(sprintf('The ResGuestRPH property can only contain items of type \StructType\ResGuestRPH, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ResGuestRPH[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ResGuestRPHsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
