<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoomRate StructType
 * @subpackage Structs
 */
class RoomRate extends RoomRateType
{
    /**
     * The AdvanceBookingRestriction
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AdvanceBookingRestriction
     */
    public $AdvanceBookingRestriction;
    /**
     * The Restrictions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Restrictions
     */
    public $Restrictions;
    /**
     * The ServiceRPHs
     * Meta information extracted from the WSDL
     * - documentation: A container for the unique references to the services for the room stay.
     * - minOccurs: 0
     * @var \StructType\ServiceRPHsType
     */
    public $ServiceRPHs;
    /**
     * The GuestCounts
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GuestCounts
     */
    public $GuestCounts;
    /**
     * Constructor method for RoomRate
     * @uses RoomRate::setAdvanceBookingRestriction()
     * @uses RoomRate::setRestrictions()
     * @uses RoomRate::setServiceRPHs()
     * @uses RoomRate::setGuestCounts()
     * @param \StructType\AdvanceBookingRestriction $advanceBookingRestriction
     * @param \StructType\Restrictions $restrictions
     * @param \StructType\ServiceRPHsType $serviceRPHs
     * @param \StructType\GuestCounts $guestCounts
     */
    public function __construct(\StructType\AdvanceBookingRestriction $advanceBookingRestriction = null, \StructType\Restrictions $restrictions = null, \StructType\ServiceRPHsType $serviceRPHs = null, \StructType\GuestCounts $guestCounts = null)
    {
        $this
            ->setAdvanceBookingRestriction($advanceBookingRestriction)
            ->setRestrictions($restrictions)
            ->setServiceRPHs($serviceRPHs)
            ->setGuestCounts($guestCounts);
    }
    /**
     * Get AdvanceBookingRestriction value
     * @return \StructType\AdvanceBookingRestriction|null
     */
    public function getAdvanceBookingRestriction()
    {
        return $this->AdvanceBookingRestriction;
    }
    /**
     * Set AdvanceBookingRestriction value
     * @param \StructType\AdvanceBookingRestriction $advanceBookingRestriction
     * @return \StructType\RoomRate
     */
    public function setAdvanceBookingRestriction(\StructType\AdvanceBookingRestriction $advanceBookingRestriction = null)
    {
        $this->AdvanceBookingRestriction = $advanceBookingRestriction;
        return $this;
    }
    /**
     * Get Restrictions value
     * @return \StructType\Restrictions|null
     */
    public function getRestrictions()
    {
        return $this->Restrictions;
    }
    /**
     * Set Restrictions value
     * @param \StructType\Restrictions $restrictions
     * @return \StructType\RoomRate
     */
    public function setRestrictions(\StructType\Restrictions $restrictions = null)
    {
        $this->Restrictions = $restrictions;
        return $this;
    }
    /**
     * Get ServiceRPHs value
     * @return \StructType\ServiceRPHsType|null
     */
    public function getServiceRPHs()
    {
        return $this->ServiceRPHs;
    }
    /**
     * Set ServiceRPHs value
     * @param \StructType\ServiceRPHsType $serviceRPHs
     * @return \StructType\RoomRate
     */
    public function setServiceRPHs(\StructType\ServiceRPHsType $serviceRPHs = null)
    {
        $this->ServiceRPHs = $serviceRPHs;
        return $this;
    }
    /**
     * Get GuestCounts value
     * @return \StructType\GuestCounts|null
     */
    public function getGuestCounts()
    {
        return $this->GuestCounts;
    }
    /**
     * Set GuestCounts value
     * @param \StructType\GuestCounts $guestCounts
     * @return \StructType\RoomRate
     */
    public function setGuestCounts(\StructType\GuestCounts $guestCounts = null)
    {
        $this->GuestCounts = $guestCounts;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RoomRate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
