<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoomTypeAllocations StructType
 * Meta information extracted from the WSDL
 * - documentation: This allows for multiple allocations to be blocked for a specific room type.
 * @subpackage Structs
 */
class RoomTypeAllocations extends AbstractStructBase
{
    /**
     * The RoomTypeAllocation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\RoomTypeAllocation[]
     */
    public $RoomTypeAllocation;
    /**
     * The RoomTypePickUpStatus
     * Meta information extracted from the WSDL
     * - documentation: Refer to OpenTravel Code list (INV) Inventory Count Type. | Used for codes in the OpenTravel Code tables. Possible values of this pattern are 1, 101, 101.EQP, or 101.EQP.X.
     * - base: xs:string
     * - pattern: [0-9A-Z]{1,3}(\.[A-Z]{3}(\.X){0,1}){0,1}
     * - use: optional
     * @var string
     */
    public $RoomTypePickUpStatus;
    /**
     * Constructor method for RoomTypeAllocations
     * @uses RoomTypeAllocations::setRoomTypeAllocation()
     * @uses RoomTypeAllocations::setRoomTypePickUpStatus()
     * @param \StructType\RoomTypeAllocation[] $roomTypeAllocation
     * @param string $roomTypePickUpStatus
     */
    public function __construct(array $roomTypeAllocation = array(), $roomTypePickUpStatus = null)
    {
        $this
            ->setRoomTypeAllocation($roomTypeAllocation)
            ->setRoomTypePickUpStatus($roomTypePickUpStatus);
    }
    /**
     * Get RoomTypeAllocation value
     * @return \StructType\RoomTypeAllocation[]|null
     */
    public function getRoomTypeAllocation()
    {
        return $this->RoomTypeAllocation;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomTypeAllocation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomTypeAllocation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomTypeAllocationForArrayConstraintsFromSetRoomTypeAllocation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $roomTypeAllocationsRoomTypeAllocationItem) {
            // validation for constraint: itemType
            if (!$roomTypeAllocationsRoomTypeAllocationItem instanceof \StructType\RoomTypeAllocation) {
                $invalidValues[] = is_object($roomTypeAllocationsRoomTypeAllocationItem) ? get_class($roomTypeAllocationsRoomTypeAllocationItem) : sprintf('%s(%s)', gettype($roomTypeAllocationsRoomTypeAllocationItem), var_export($roomTypeAllocationsRoomTypeAllocationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomTypeAllocation property can only contain items of type \StructType\RoomTypeAllocation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomTypeAllocation value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomTypeAllocation[] $roomTypeAllocation
     * @return \StructType\RoomTypeAllocations
     */
    public function setRoomTypeAllocation(array $roomTypeAllocation = array())
    {
        // validation for constraint: array
        if ('' !== ($roomTypeAllocationArrayErrorMessage = self::validateRoomTypeAllocationForArrayConstraintsFromSetRoomTypeAllocation($roomTypeAllocation))) {
            throw new \InvalidArgumentException($roomTypeAllocationArrayErrorMessage, __LINE__);
        }
        $this->RoomTypeAllocation = $roomTypeAllocation;
        return $this;
    }
    /**
     * Add item to RoomTypeAllocation value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomTypeAllocation $item
     * @return \StructType\RoomTypeAllocations
     */
    public function addToRoomTypeAllocation(\StructType\RoomTypeAllocation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomTypeAllocation) {
            throw new \InvalidArgumentException(sprintf('The RoomTypeAllocation property can only contain items of type \StructType\RoomTypeAllocation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomTypeAllocation[] = $item;
        return $this;
    }
    /**
     * Get RoomTypePickUpStatus value
     * @return string|null
     */
    public function getRoomTypePickUpStatus()
    {
        return $this->RoomTypePickUpStatus;
    }
    /**
     * Set RoomTypePickUpStatus value
     * @param string $roomTypePickUpStatus
     * @return \StructType\RoomTypeAllocations
     */
    public function setRoomTypePickUpStatus($roomTypePickUpStatus = null)
    {
        // validation for constraint: string
        if (!is_null($roomTypePickUpStatus) && !is_string($roomTypePickUpStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($roomTypePickUpStatus, true), gettype($roomTypePickUpStatus)), __LINE__);
        }
        // validation for constraint: pattern([0-9A-Z]{1,3}(\.[A-Z]{3}(\.X){0,1}){0,1})
        if (!is_null($roomTypePickUpStatus) && !preg_match('/[0-9A-Z]{1,3}(\\.[A-Z]{3}(\\.X){0,1}){0,1}/', $roomTypePickUpStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression [0-9A-Z]{1,3}(\.[A-Z]{3}(\.X){0,1}){0,1}', var_export($roomTypePickUpStatus, true)), __LINE__);
        }
        $this->RoomTypePickUpStatus = $roomTypePickUpStatus;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RoomTypeAllocations
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
