<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoutingHopType StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of RoutingHop objects. his details the path that the original request or notification traveled.
 * @subpackage Structs
 */
class RoutingHopType extends AbstractStructBase
{
    /**
     * The RoutingHop
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\RoutingHop[]
     */
    public $RoutingHop;
    /**
     * Constructor method for RoutingHopType
     * @uses RoutingHopType::setRoutingHop()
     * @param \StructType\RoutingHop[] $routingHop
     */
    public function __construct(array $routingHop = array())
    {
        $this
            ->setRoutingHop($routingHop);
    }
    /**
     * Get RoutingHop value
     * @return \StructType\RoutingHop[]|null
     */
    public function getRoutingHop()
    {
        return $this->RoutingHop;
    }
    /**
     * This method is responsible for validating the values passed to the setRoutingHop method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoutingHop method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoutingHopForArrayConstraintsFromSetRoutingHop(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $routingHopTypeRoutingHopItem) {
            // validation for constraint: itemType
            if (!$routingHopTypeRoutingHopItem instanceof \StructType\RoutingHop) {
                $invalidValues[] = is_object($routingHopTypeRoutingHopItem) ? get_class($routingHopTypeRoutingHopItem) : sprintf('%s(%s)', gettype($routingHopTypeRoutingHopItem), var_export($routingHopTypeRoutingHopItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoutingHop property can only contain items of type \StructType\RoutingHop, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoutingHop value
     * @throws \InvalidArgumentException
     * @param \StructType\RoutingHop[] $routingHop
     * @return \StructType\RoutingHopType
     */
    public function setRoutingHop(array $routingHop = array())
    {
        // validation for constraint: array
        if ('' !== ($routingHopArrayErrorMessage = self::validateRoutingHopForArrayConstraintsFromSetRoutingHop($routingHop))) {
            throw new \InvalidArgumentException($routingHopArrayErrorMessage, __LINE__);
        }
        $this->RoutingHop = $routingHop;
        return $this;
    }
    /**
     * Add item to RoutingHop value
     * @throws \InvalidArgumentException
     * @param \StructType\RoutingHop $item
     * @return \StructType\RoutingHopType
     */
    public function addToRoutingHop(\StructType\RoutingHop $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoutingHop) {
            throw new \InvalidArgumentException(sprintf('The RoutingHop property can only contain items of type \StructType\RoutingHop, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoutingHop[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RoutingHopType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
