<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SpecialServiceRequests StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of Special Service Request.
 * @subpackage Structs
 */
class SpecialServiceRequests extends AbstractStructBase
{
    /**
     * The SpecialServiceRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\SpecialServiceRequest[]
     */
    public $SpecialServiceRequest;
    /**
     * Constructor method for SpecialServiceRequests
     * @uses SpecialServiceRequests::setSpecialServiceRequest()
     * @param \StructType\SpecialServiceRequest[] $specialServiceRequest
     */
    public function __construct(array $specialServiceRequest = array())
    {
        $this
            ->setSpecialServiceRequest($specialServiceRequest);
    }
    /**
     * Get SpecialServiceRequest value
     * @return \StructType\SpecialServiceRequest[]|null
     */
    public function getSpecialServiceRequest()
    {
        return $this->SpecialServiceRequest;
    }
    /**
     * This method is responsible for validating the values passed to the setSpecialServiceRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSpecialServiceRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSpecialServiceRequestForArrayConstraintsFromSetSpecialServiceRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $specialServiceRequestsSpecialServiceRequestItem) {
            // validation for constraint: itemType
            if (!$specialServiceRequestsSpecialServiceRequestItem instanceof \StructType\SpecialServiceRequest) {
                $invalidValues[] = is_object($specialServiceRequestsSpecialServiceRequestItem) ? get_class($specialServiceRequestsSpecialServiceRequestItem) : sprintf('%s(%s)', gettype($specialServiceRequestsSpecialServiceRequestItem), var_export($specialServiceRequestsSpecialServiceRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SpecialServiceRequest property can only contain items of type \StructType\SpecialServiceRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SpecialServiceRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\SpecialServiceRequest[] $specialServiceRequest
     * @return \StructType\SpecialServiceRequests
     */
    public function setSpecialServiceRequest(array $specialServiceRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($specialServiceRequestArrayErrorMessage = self::validateSpecialServiceRequestForArrayConstraintsFromSetSpecialServiceRequest($specialServiceRequest))) {
            throw new \InvalidArgumentException($specialServiceRequestArrayErrorMessage, __LINE__);
        }
        $this->SpecialServiceRequest = $specialServiceRequest;
        return $this;
    }
    /**
     * Add item to SpecialServiceRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\SpecialServiceRequest $item
     * @return \StructType\SpecialServiceRequests
     */
    public function addToSpecialServiceRequest(\StructType\SpecialServiceRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SpecialServiceRequest) {
            throw new \InvalidArgumentException(sprintf('The SpecialServiceRequest property can only contain items of type \StructType\SpecialServiceRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SpecialServiceRequest[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SpecialServiceRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
