<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StatisticApplicationSetType StructType
 * Meta information extracted from the WSDL
 * - documentation: Includes the statistic data reported and the codes for which it has been aggregated, if applicable. The applicable date range for the data is defined in its attributes.
 * @subpackage Structs
 */
class StatisticApplicationSetType extends AbstractStructBase
{
    /**
     * The StatisticCodes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\StatisticCodes
     */
    public $StatisticCodes;
    /**
     * The RevenueCategorySummaries
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RevenueCategorySummaries
     */
    public $RevenueCategorySummaries;
    /**
     * The CountCategorySummaries
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CountCategorySummaries
     */
    public $CountCategorySummaries;
    /**
     * The ReportSummaries
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ReportSummaries
     */
    public $ReportSummaries;
    /**
     * The Start
     * Meta information extracted from the WSDL
     * - documentation: A construct to validate either a date or a time or a dateTime value.
     * - union: date | dateTime | time
     * @var string
     */
    public $Start;
    /**
     * The Duration
     * Meta information extracted from the WSDL
     * - documentation: Allows for the specification of a night duration.
     * - union: duration | NightDurationType
     * @var string
     */
    public $Duration;
    /**
     * The End
     * Meta information extracted from the WSDL
     * - documentation: A construct to validate either a date or a time or a dateTime value.
     * - union: date | dateTime | time
     * @var string
     */
    public $End;
    /**
     * Constructor method for StatisticApplicationSetType
     * @uses StatisticApplicationSetType::setStatisticCodes()
     * @uses StatisticApplicationSetType::setRevenueCategorySummaries()
     * @uses StatisticApplicationSetType::setCountCategorySummaries()
     * @uses StatisticApplicationSetType::setReportSummaries()
     * @uses StatisticApplicationSetType::setStart()
     * @uses StatisticApplicationSetType::setDuration()
     * @uses StatisticApplicationSetType::setEnd()
     * @param \StructType\StatisticCodes $statisticCodes
     * @param \StructType\RevenueCategorySummaries $revenueCategorySummaries
     * @param \StructType\CountCategorySummaries $countCategorySummaries
     * @param \StructType\ReportSummaries $reportSummaries
     * @param string $start
     * @param string $duration
     * @param string $end
     */
    public function __construct(\StructType\StatisticCodes $statisticCodes = null, \StructType\RevenueCategorySummaries $revenueCategorySummaries = null, \StructType\CountCategorySummaries $countCategorySummaries = null, \StructType\ReportSummaries $reportSummaries = null, $start = null, $duration = null, $end = null)
    {
        $this
            ->setStatisticCodes($statisticCodes)
            ->setRevenueCategorySummaries($revenueCategorySummaries)
            ->setCountCategorySummaries($countCategorySummaries)
            ->setReportSummaries($reportSummaries)
            ->setStart($start)
            ->setDuration($duration)
            ->setEnd($end);
    }
    /**
     * Get StatisticCodes value
     * @return \StructType\StatisticCodes|null
     */
    public function getStatisticCodes()
    {
        return $this->StatisticCodes;
    }
    /**
     * Set StatisticCodes value
     * @param \StructType\StatisticCodes $statisticCodes
     * @return \StructType\StatisticApplicationSetType
     */
    public function setStatisticCodes(\StructType\StatisticCodes $statisticCodes = null)
    {
        $this->StatisticCodes = $statisticCodes;
        return $this;
    }
    /**
     * Get RevenueCategorySummaries value
     * @return \StructType\RevenueCategorySummaries|null
     */
    public function getRevenueCategorySummaries()
    {
        return $this->RevenueCategorySummaries;
    }
    /**
     * Set RevenueCategorySummaries value
     * @param \StructType\RevenueCategorySummaries $revenueCategorySummaries
     * @return \StructType\StatisticApplicationSetType
     */
    public function setRevenueCategorySummaries(\StructType\RevenueCategorySummaries $revenueCategorySummaries = null)
    {
        $this->RevenueCategorySummaries = $revenueCategorySummaries;
        return $this;
    }
    /**
     * Get CountCategorySummaries value
     * @return \StructType\CountCategorySummaries|null
     */
    public function getCountCategorySummaries()
    {
        return $this->CountCategorySummaries;
    }
    /**
     * Set CountCategorySummaries value
     * @param \StructType\CountCategorySummaries $countCategorySummaries
     * @return \StructType\StatisticApplicationSetType
     */
    public function setCountCategorySummaries(\StructType\CountCategorySummaries $countCategorySummaries = null)
    {
        $this->CountCategorySummaries = $countCategorySummaries;
        return $this;
    }
    /**
     * Get ReportSummaries value
     * @return \StructType\ReportSummaries|null
     */
    public function getReportSummaries()
    {
        return $this->ReportSummaries;
    }
    /**
     * Set ReportSummaries value
     * @param \StructType\ReportSummaries $reportSummaries
     * @return \StructType\StatisticApplicationSetType
     */
    public function setReportSummaries(\StructType\ReportSummaries $reportSummaries = null)
    {
        $this->ReportSummaries = $reportSummaries;
        return $this;
    }
    /**
     * Get Start value
     * @return string|null
     */
    public function getStart()
    {
        return $this->Start;
    }
    /**
     * This method is responsible for validating the value passed to the setStart method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStart method
     * This is a set of validation rules based on the union types associated to the property being set by the setStart method
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStartForUnionConstraintsFromSetStart($value)
    {
        $message = '';
        if () {
            $message = sprintf("The value %s does not match any of the union rules: date, dateTime, time. See following errors:\n%s", var_export($value, true), implode("\n", array_map(function(\InvalidArgumentException $e) { return sprintf(' - %s', $e->getMessage()); }, [])));
        }
        unset();
        return $message;
    }
    /**
     * Set Start value
     * @param string $start
     * @return \StructType\StatisticApplicationSetType
     */
    public function setStart($start = null)
    {
        // validation for constraint: string
        if (!is_null($start) && !is_string($start)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($start, true), gettype($start)), __LINE__);
        }
        // validation for constraint: union(date, dateTime, time)
        if ('' !== ($startUnionErrorMessage = self::validateStartForUnionConstraintsFromSetStart($start))) {
            throw new \InvalidArgumentException($startUnionErrorMessage, __LINE__);
        }
        $this->Start = $start;
        return $this;
    }
    /**
     * Get Duration value
     * @return string|null
     */
    public function getDuration()
    {
        return $this->Duration;
    }
    /**
     * This method is responsible for validating the value passed to the setDuration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDuration method
     * This is a set of validation rules based on the union types associated to the property being set by the setDuration method
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDurationForUnionConstraintsFromSetDuration($value)
    {
        $message = '';
        // validation for constraint: pattern(P[0-9]{1,3}N)
        if (!is_null($value) && !preg_match('/P[0-9]{1,3}N/', $value)) {
            $exception0 = new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression P[0-9]{1,3}N', var_export($value, true)), __LINE__);
        }
        if (isset($exception0)) {
            $message = sprintf("The value %s does not match any of the union rules: duration, NightDurationType. See following errors:\n%s", var_export($value, true), implode("\n", array_map(function(\InvalidArgumentException $e) { return sprintf(' - %s', $e->getMessage()); }, [$exception0])));
        }
        unset($exception0);
        return $message;
    }
    /**
     * Set Duration value
     * @param string $duration
     * @return \StructType\StatisticApplicationSetType
     */
    public function setDuration($duration = null)
    {
        // validation for constraint: string
        if (!is_null($duration) && !is_string($duration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($duration, true), gettype($duration)), __LINE__);
        }
        // validation for constraint: union(duration, NightDurationType)
        if ('' !== ($durationUnionErrorMessage = self::validateDurationForUnionConstraintsFromSetDuration($duration))) {
            throw new \InvalidArgumentException($durationUnionErrorMessage, __LINE__);
        }
        $this->Duration = $duration;
        return $this;
    }
    /**
     * Get End value
     * @return string|null
     */
    public function getEnd()
    {
        return $this->End;
    }
    /**
     * This method is responsible for validating the value passed to the setEnd method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEnd method
     * This is a set of validation rules based on the union types associated to the property being set by the setEnd method
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEndForUnionConstraintsFromSetEnd($value)
    {
        $message = '';
        if () {
            $message = sprintf("The value %s does not match any of the union rules: date, dateTime, time. See following errors:\n%s", var_export($value, true), implode("\n", array_map(function(\InvalidArgumentException $e) { return sprintf(' - %s', $e->getMessage()); }, [])));
        }
        unset();
        return $message;
    }
    /**
     * Set End value
     * @param string $end
     * @return \StructType\StatisticApplicationSetType
     */
    public function setEnd($end = null)
    {
        // validation for constraint: string
        if (!is_null($end) && !is_string($end)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($end, true), gettype($end)), __LINE__);
        }
        // validation for constraint: union(date, dateTime, time)
        if ('' !== ($endUnionErrorMessage = self::validateEndForUnionConstraintsFromSetEnd($end))) {
            throw new \InvalidArgumentException($endUnionErrorMessage, __LINE__);
        }
        $this->End = $end;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StatisticApplicationSetType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
