<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Surcharge StructType
 * Meta information extracted from the WSDL
 * - documentation: This element is used to describe one specific surcharge that may apply.
 * @subpackage Structs
 */
class Surcharge extends VehicleChargeType
{
    /**
     * The Info
     * Meta information extracted from the WSDL
     * - documentation: Information on this one specific surcharge, including a description, etc.
     * - minOccurs: 0
     * @var \StructType\FormattedTextType
     */
    public $Info;
    /**
     * Constructor method for Surcharge
     * @uses Surcharge::setInfo()
     * @param \StructType\FormattedTextType $info
     */
    public function __construct(\StructType\FormattedTextType $info = null)
    {
        $this
            ->setInfo($info);
    }
    /**
     * Get Info value
     * @return \StructType\FormattedTextType|null
     */
    public function getInfo()
    {
        return $this->Info;
    }
    /**
     * Set Info value
     * @param \StructType\FormattedTextType $info
     * @return \StructType\Surcharge
     */
    public function setInfo(\StructType\FormattedTextType $info = null)
    {
        $this->Info = $info;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Surcharge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
