<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TransportationsType StructType
 * Meta information extracted from the WSDL
 * - documentation: Used to define the types of transportation offered.
 * @subpackage Structs
 */
class TransportationsType extends AbstractStructBase
{
    /**
     * The Transportations
     * Meta information extracted from the WSDL
     * - documentation: Collection of directions to/from a specific location via various modes of transportation.
     * - minOccurs: 0
     * @var \StructType\TransportationType
     */
    public $Transportations;
    /**
     * Constructor method for TransportationsType
     * @uses TransportationsType::setTransportations()
     * @param \StructType\TransportationType $transportations
     */
    public function __construct(\StructType\TransportationType $transportations = null)
    {
        $this
            ->setTransportations($transportations);
    }
    /**
     * Get Transportations value
     * @return \StructType\TransportationType|null
     */
    public function getTransportations()
    {
        return $this->Transportations;
    }
    /**
     * Set Transportations value
     * @param \StructType\TransportationType $transportations
     * @return \StructType\TransportationsType
     */
    public function setTransportations(\StructType\TransportationType $transportations = null)
    {
        $this->Transportations = $transportations;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TransportationsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
