<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleResRSCoreType StructType
 * Meta information extracted from the WSDL
 * - documentation: The VehicleResRSCoreType complex type identifies the core, or common, information that is associated with the reservation of a vehicle.
 * @subpackage Structs
 */
class VehicleResRSCoreType extends AbstractStructBase
{
    /**
     * The VehReservation
     * Meta information extracted from the WSDL
     * - documentation: Represents the vehicle rental reservation that was successfully created.
     * @var \StructType\VehicleReservationType
     */
    public $VehReservation;
    /**
     * The TPA_Extensions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: TPA_Extensions
     * @var \StructType\TPA_ExtensionsType
     */
    public $TPA_Extensions;
    /**
     * Constructor method for VehicleResRSCoreType
     * @uses VehicleResRSCoreType::setVehReservation()
     * @uses VehicleResRSCoreType::setTPA_Extensions()
     * @param \StructType\VehicleReservationType $vehReservation
     * @param \StructType\TPA_ExtensionsType $tPA_Extensions
     */
    public function __construct(\StructType\VehicleReservationType $vehReservation = null, \StructType\TPA_ExtensionsType $tPA_Extensions = null)
    {
        $this
            ->setVehReservation($vehReservation)
            ->setTPA_Extensions($tPA_Extensions);
    }
    /**
     * Get VehReservation value
     * @return \StructType\VehicleReservationType|null
     */
    public function getVehReservation()
    {
        return $this->VehReservation;
    }
    /**
     * Set VehReservation value
     * @param \StructType\VehicleReservationType $vehReservation
     * @return \StructType\VehicleResRSCoreType
     */
    public function setVehReservation(\StructType\VehicleReservationType $vehReservation = null)
    {
        $this->VehReservation = $vehReservation;
        return $this;
    }
    /**
     * Get TPA_Extensions value
     * @return \StructType\TPA_ExtensionsType|null
     */
    public function getTPA_Extensions()
    {
        return $this->TPA_Extensions;
    }
    /**
     * Set TPA_Extensions value
     * @param \StructType\TPA_ExtensionsType $tPA_Extensions
     * @return \StructType\VehicleResRSCoreType
     */
    public function setTPA_Extensions(\StructType\TPA_ExtensionsType $tPA_Extensions = null)
    {
        $this->TPA_Extensions = $tPA_Extensions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VehicleResRSCoreType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
